{-----------------------------------------------------------------------------

        HELPMAKE 1.20 -=- Turbo Helpfile-Compiler (THELP-Format)

        zu compilieren mit TurboPascal 4.0/5.0/5.5/6.0

        written by Marcus Grber 1991
	Special thanks to Torsten Brand

-----------------------------------------------------------------------------}

{$IFNDEF VER40} {$A+,E+,O-} {$ENDIF}  { Neue Compileroptionen nur ab 5.0 }
{$B-,F-,I+,L+,N-,R-,S-,V-}
{$M 8192,65536,655360}

program helpmake;

uses Dos;

const
  LabelLen=16;
  max_pages = 9999;		       { Maximale Seitennummer }
  def_height = 15;		       { Maximale Gre einer Seite }
  def_width  = 48;
  window_x   = 15;		       { Koordinaten linke obere Fensterecke }
  window_y   = 5;
  def_Title:string = 'HELP FILE.';
  ident:string = '$*$* &&&&$*$';       { Identifikationsstring }
  def_Markers:string = '##~`';
  MaxFileLevel=10;		       { Maximale Include-File-Schachtelung }
  HashConst=199;

type
  PageRec = record
	      L,M,H: byte;
	    end;
  LabelStr = string[LabelLen];
  headtype= array [1..18] of byte;
  IndexPtr = ^IndexRec;
  IndexRec = record
	       entry: string[32];
	       ref:   word;
	       next:  IndexPtr;
	     end;
  Nibble  = $0..$F;
  PageDescPtr = ^PageDesc;
  PageDesc = record
	       Page: word;
	       Next: PageDescPtr;
	       Lab:  LabelStr;
	     end;
  WordP    = ^word;

const
  stdhead: headtype =
   (  $00,	    { <<< Versionsnummer }
      $00,	    { <<< Code des Programms, zu dem die Hilfsdatei gehrt }
     $00,
      $00,          { <<< 14h bei alten, 09h bei neuen Dateien }
     $00,
      $00,	    { <<< Bit 3 gesetzt, wenn 'case sensitive' }
     $00,
      $00,$00,	    {*<<< Hierher kommt die Indexseite }
      $00,$00,	    {*<<< Hierher kommt der maximale Seitenumfang }
      $00,	    { <<< Nutzbare Zeilen im Fenster }
      $00,	    { <<< Nutzbare Spalten im Fenster }
      $00,	    { <<< Rand des Fensters }
     window_y,	    {*Y-Koordinate l/o-Ecke des Fensters }
     window_x,	    {*X-Koordinate l/o-Ecke des Fensters }
     $00,	    {*}
     $02);
  { Das Zeichen * kennzeichnet Eintrge, die nur im neuen Format exisitieren }

  NoPage:   PageRec=(L:$FF;M:$FF;H:$FF);  { Kennzeichen fr 'Keine Seite' }
  RsvdPage: PageRec=(L:$FF;M:$FF;H:$FE);  { Kennzeichen fr 'reserviert' }

var
  Compress:  array [0..16383] of byte;    { Ein solider Puffer... }
  f:	     file of byte;
  inp:	     array[1..MaxFileLevel] of text;
  linenum:   array[1..MaxFileLevel] of longint;
  FileLevel: byte;
  infile:    string;
  outfile:   string;
  par:	     string;
  parnum:    byte;
  namepar:   byte;
  s,s1:	     string;
  CurntLine: string;
  newent:    string[32];
  ptr,ptr2:  IndexPtr;
  optr:	     IndexPtr;
  i,j,l,p:   byte;
  k:         integer;
  c:	     char;
  ref:	     word;
  sorted:    boolean;
  maxocc:    longint;
  maxocc_i:  longint;
  pptr,pptr2:PageDescPtr;
  HashList:  array [0..HashConst] of PageDescPtr;
  PageList:  array [0..max_pages] of PageRec;   { 30-Kilobyte-Array! }
  ForwardRef: boolean;
  Pass:	      1..2;
  c_markers:  string[4];
  Idx:	      IndexPtr;
  Idx_n:      word;
  FoundErrors:word;
  Undefined:  word;
  PageNumber: word;
  FreePage:   word;
  RunningPage:word;
  MaxSize:    word;
  DefaultPage:word;
  DefaultPos: PageRec;
  IndexPage:  word;
  occ:	      array [0..255] of longint;
  short:      array [0..13] of char;
  IndexLength:longint;
  Title:      string[40];
  head:	      headtype;
  hdrsize:    byte;
  version:    byte;
  TypeID:     integer;
  Autopage:   boolean;
  FootSpace:  word;
  HeadSpace:  word;
  scr_height: byte;
  scr_width:  byte;
  scr_marg:   byte;
  but_offset: byte;
  case_sensitive: boolean;
  ProgCode:   byte;
  StoredLine: string;
  UnRead:     boolean;
  ButtonL:    WordP;

{$I HELPTOOL.INC}

var
  Time,Time2: TimeRec;

{----------------------------------------------------------------------------}
function GetFileName(var TheFile: text): string;
{----------------------------------------------------------------------------
  Diese Funktion liefert den Namen, der der bergebenen Textdatei zugeordnet
  ist. Dies ist ntig, da das Feld TextRec(...).Name einen ASCIIZ-String
  (durch Nullbyte beendet) und nicht einen TurboPascal-String enthlt.
 ----------------------------------------------------------------------------}
var
  s: string;
begin
  s:='';
  i:=0;			               { Anfang des Dateinamens }
  while TextRec(TheFile).name[i]<>#0 do{ Namensfeld der Filevariablen lesen }
    begin                              { Dateinamen bis #0 zusammensetzen }
      ConcatChar(s,UpCase(TextRec(TheFile).name[i]));
      inc(i);		               { Nchstes Zeichen }
    end;
  GetFileName:=s;                      { Dateinamen zurckgeben }
end;

{----------------------------------------------------------------------------}
procedure Error(err: string);
{----------------------------------------------------------------------------
  Diese Prozedur sorgt fr die Ausgabe des  Compilerfehlers 'err', zusammen
  mit der Zeile, in der er vorkam, und fr die Fehlerzhlung.
 ----------------------------------------------------------------------------}
var
  i:	    byte;
  filename: string;
begin
  writeln(err);
  writeln(' ',linenum[FileLevel]:5,': ''',CurntLine,'''');
  if FileLevel>1 then		       { Innerhalb einer Include-Datei? }
    writeln('':8,GetFileName(inp[FileLevel]));
                                       { Dann noch Dateinamen ausgeben }
  inc(FoundErrors);
end;

{----------------------------------------------------------------------------}
procedure Critical(err: string);
{----------------------------------------------------------------------------
  Diese Prozedur meldet einen kritischen Fehler bei der Compilierung und
  bricht das Programm sofort ab.
 ----------------------------------------------------------------------------}
begin
  Error('Critical error: '+err);
  writeln;
  writeln(' Program aborted during pass ',pass,'.');
  halt(1);
end;

{----------------------------------------------------------------------------}
{$F+} function HeapErrorHandler(size: word): Integer; {$F-}
{----------------------------------------------------------------------------
  Diese Funktion dient der Behandlung von Heap-Fehlern. Sie sorgt dafr, da
  das Programm im Falle eines Speicherberlaufs geordnet mit einer Fehler-
  meldung abgebrochen wird.
 ----------------------------------------------------------------------------}
begin
  if size>0 then                        { size=0 ist kein Fehler (Turbo 6.0) }
    Critical('Insufficent memory');
end;

{----------------------------------------------------------------------------}
procedure ReadLine(var s: string);
{----------------------------------------------------------------------------
  Eine Zeile aus der Datei 'inp' in die Variable 's' lesen. Die globale
  Variable 'linenum' zhlt die gelesenen Zeilen. Auerdem werden Tabulatoren
  expandiert (8er-Tabs); Leerzeichen/Tabulatoren am Zeilenende entfallen.
 ----------------------------------------------------------------------------}
var
  i: byte;
  j: byte;
begin
  if UnRead then                       { Noch eine gepufferte Zeile da? }
    begin
      s:=StoredLine;                   { Zeile aus dem Puffer zurckgeben }
      UnRead:=false;                   { Das wre erledigt }
      exit;                            { Schon fertig }
    end;
  readln(inp[FileLevel],s);	       { Zeile aus der Datei holen }
  inc(linenum[FileLevel]);	       { Zeilenzhlung }
  i:=1;				       { Begin at the beginning... }
  while i<=length(s) do		       { ...till you come to the end }
    begin
      if s[i]=#09 then			 { Tabulator? }
	begin
	  s[i]:=' ';			 { Durch Leerstelle ersetzen }
	  j:=(i-1) mod 8;		 { Zeichen davor seit letztem Tab }
	  while j<7 do			 { Solange noch Zeichen ntig }
	    begin
	      inc(i);			 { Position fr nchstes Zeichen }
	      insert(' ',s,i);		 { Ein Zeichen einfgen }
	      inc(j);			 { Zeichen seit letztem Tab zhlen }
	    end;
	end;
      inc(i);				 { Nchstes Zeichen }
    end;			       { ...then stop }
  while (length(s)>0) and (s[length(s)]=' ') do
				       { Noch Leerzeichen am Ende? }
    delete(s,length(s),1);	       { Weg damit! }
  CurntLine:=s;			       { Aktuelle Zeile merken }
end;

{----------------------------------------------------------------------------}
procedure UnReadLine(var s: string);
{----------------------------------------------------------------------------
  Diese Prozedur schiebt eine bereits gelesene Eingabezeile (scheinbar)
  wieder zurck in die Datei, so da der der nchste 'ReadLine'-Aufruf erneut
  diese Zeile liefert.
 ----------------------------------------------------------------------------}
begin
  StoredLine:=s;                       { Zeile speichern }
  UnRead:=true;                        { Kennzeichen: Zeile im Puffer }
end;

{----------------------------------------------------------------------------}
function ScanPage(var s: string; var p: byte; var c: char;
		  Define: boolean): word;
{----------------------------------------------------------------------------
  Diese Prozedur liest aus dem String 's' aber Position 'p' eine Seitennumer
  ein und liefert diese zurck. Nach der Rckkehr zeigt 'p' hinter die ge-
  lesene Seitennumer, 'c' gibt das Trennzeichen danach an. Wird der Wert
  $FFFF zurckgegeben, so wurde keine gltige Seitenreferenz gefunden.
  Als Seitennumer kann sowohl eine absolute Zahl als auch ein Label benutzt
  werden. Im Falle eines Labels wird die ihm zugeordnete Seitennumer zurck-
  geliefert. Neue Seiten werden nur dann im Seitenverzeichnis eingetragen,
  wenn beim Aufruf das Flag 'Define' auf true gesetzt ist. Bei der Neuanlage
  eines Labels wird zuerst versucht, diesen auf eine Lcke in den bisher
  existierenden Seiten zu setzen.
  Zustzlich zu diesem Aktionen erfolgen berprfungen auf undefinierte
  Seiten (im zweiten Durchlauf) und auf den Zugriff ber eine absolute
  Seitennumer auf eine Seite, die einem Label zugeordnet ist.

  Side effects:
    ForwardRef:  true, wenn im Pass 1 ein noch undefinierter Label auftaucht
    PageNumber:  wird entsprechend aktualisiert
    FreePage:    "    "            "
 ----------------------------------------------------------------------------}
var
  page: word;
  p2:	byte;
  lb:	LabelStr;
  i:    byte;
  Sum:  word;
  Hash: word;
  pptr,pptr2,pptr3: PageDescPtr;
begin
  ForwardRef:=false;
  p2:=p;			       { Alten Stringszeiger merken }
  page:=ScanNum(s,p,c);		       { Versuchen, eine Zahl einzulesen }
  if page<>$FFFF then		       { Gltige Zahl? }
{ Absolute Seitenzahl verarbeiten }
    if (page>0) and (page<=max_pages) then
      begin			       { Korrekte Seitenzahl? }
        if (pass=1) and Define then
          if (PageList[page].H=RsvdPage.H) and Define then
                                       { Zu definierende Seite schon belegt? }
            error('Duplicate page definition')
                                       { Ja: Fehler }
          else
            PageList[page]:=RsvdPage;  { Nein: Seite belegen }
        ScanPage:=page;                { Rckgabe: Seitenzahl }
        if page>PageNumber then        { Seitenanzahl aktualisieren }
          PageNumber:=page;
      end
    else
      ScanPage:=$FFFF		       { Rckgabe: Ungltige Seitenzahl }
  else
{ Labels verarbeiten }
    begin
      p:=p2;			       { Zurck zum Labelanfang }
      Lb:=ScanLabel(s,p,c);	       { Label einlesen }
      if Lb=''then		       { Kein Label gefunden }
	ScanPage:=$FFFF		       { Rckgabe: Ungltige Seite }
      else
	begin
          Sum:=0;                      { Quersumme zurcksetzen }
          for i:=1 to length(Lb) do    { Alle Zeichen durch }
            inc(Sum,byte(Lb[i]));      { Quersumme des Labels }
          Hash:=Sum mod HashConst;     { Hash-Wert berechnen }
          pptr:=HashList[Hash];        { Teilliste bestimmen }
          pptr2:=NIL;                  { Zeiger auf vorhergehendes Element }
          while (pptr<>NIL) and (pptr^.Lab<>Lb) do
            begin                      { Teilliste nach 'Lb' durchsuchen }
              pptr2:=pptr;
              pptr:=pptr^.next;
            end;
          ScanPage:=1;                 { Vorgabe: "Irgendeine" Seite zurck }
          if pass=1 then
{ Im ersten Durchlauf... }
            if Define then             { Label-Definition }
              if (pptr<>NIL) then      { Label in Pass 1 doppelt definiert }
                error('Duplicate label: '''+Lb+'''')
              else
                begin
                  New(pptr3);          { Platz fr neuen Eintrag }
                  pptr3^.next:=pptr;   { Verkettung auf nchstes Element }
                  if pptr2=NIL then    { Erstes Element in der Kette? }
                    HashList[Hash]:=pptr3
                                       { Dann Listenanfang setzen }
                  else
                    pptr2^.next:=pptr3;{ Verkettung im vorhergehenden Element }
                  pptr3^.lab:=Lb;      { Label in Eintrag speichern }
                  while PageList[FreePage].H=RsvdPage.H do
                    inc(FreePage);     { Nicht-reservierte Seite suchen }
                  page:=FreePage;
                  pptr3^.Page:=Page;   { Seite dem Label zuweisen }
                  if page>PageNumber then
                                       { Seitenanzahl aktualisieren }
                    PageNumber:=page;
                  ScanPage:=Page;      { Rckgabe: zugewiesene Seite }
                  PageList[page]:=RsvdPage;
                                       { Seite reservieren }
                end
            else                       { Verweis auf Label }
              begin
                ForwardRef:=(pptr=NIL);{ Label undefiniert: Vorwrts-Referenz }
                if not ForwardRef then { Label definiert? }
                  ScanPage:=pptr^.page;{ Dann Seite des Labels zurck }
              end
          else
{ Im zweiten Durchlauf... }
            if pptr=NIL then           { Undefinierter Label? }
              error('Undefined label: '''+Lb+'''')
            else
              ScanPage:=pptr^.Page;    { Seitenzahl des Labels zurck }
	end;
    end;
end;

{----------------------------------------------------------------------------}
procedure ProcessPage;
{----------------------------------------------------------------------------
  Die folgende Mammut-Prozedur sorgt dafr, da...
    ... die Nummerierung am Anfang einer Seitenbeschreibung gelesen und im
	1. Durchlauf die maximale Seitenzahl ermittelt bzw. im
	2. Durchlauf das Seitenverzeichnis erstellt wird.
    ... der eigentliche Seitentext gelesen und im
	1. Durchlauf die Hufigkeit der einzelnen Zeichen bestimmt bzw. im
	2. Durchlauf der Text in die Zieldatei komprimiert wird (zusammen
	   mit Vorwrts-/Rckwrts-Verknpfungen ber PgUp/PgDn). Zustzlich
	   werden die Koordinaten der Topic-Buttons abgelegt, anschlieend
	   entsprechend verknpft (Cursorbewegungen) und ebenfalls in die
	   Datei geschrieben.
  Beim Aufruf mu 'inp' hinter die Anfangszeile des Seitendeskriptors
  ('<Marker>P <Seitennummer>') stehen, 's' mu diese Zeile enthalten. Die
  komprimierte Seite wird an der momentanen Position von 'f' abgelegt.
  Nach der Rckkehr steht 'inp' auf dem Anfang der Zeile dem Ende der Seiten-
  beschreibung, 'f' steht hinter der letzten geschriebenen Seite.
 ----------------------------------------------------------------------------}

type
  ButtonRec = record
		XPos: integer;	       { wegen Vorzeichen }
		XEnd: integer;
		YPos: byte;
		Ref:  word;
	      end;
var
  LastNib: Nibble;
  WriteNow:boolean;
  LastCh:  char;
  ChRep:   byte;
  ByteCnt: word;
  insh:	   Nibble;
  pnum:	   word;
  endpage: boolean;
  newline: boolean;
  line:    word;
  col:     byte;
  inbut:   boolean;
  pos:	   longint;
  Button:   array [1..100] of ButtonRec; { Das mu ausreichen! }
  ButtFlip: array [1..100] of byte;
  ButtCnt:   word;
  WriteButt: byte;
  FirstButton: byte;
  Wrap:	   boolean;
  UpPage:  word;
  DnPage:  word;
  EndSequ: boolean;
  forcedpage: boolean;
  created: boolean;
  ignorel: boolean;

  {---------------------------------------------------------------------------}
  function ButtonLP(page: word): WordP;
  {---------------------------------------------------------------------------}
  begin
    ButtonLP:=System.Ptr(Seg(ButtonL^),Ofs(ButtonL^)+page*2);
  end;

  {--------------------------------------------------------------------------}
  procedure WriteNibble(v: Nibble);
  {--------------------------------------------------------------------------
    Diese Prozedur schreibt das Halbbyte (Nibble) 'v' in die Datei 'f'. Dabei
    werden jeweils zwei aufeinanderfolgende Aufrufe in ein Byte zusammen-
    gefat. 'WriteNow' gibt an, ob noch ein Halbbyte im Puffer steht.
   --------------------------------------------------------------------------}
  begin
    if WriteNow then
      begin
	Compress[ByteCnt]:=LastNib+v*16;
	inc(ByteCnt);
      end
    else
      LastNib:=v;
    WriteNow:=not WriteNow;
  end;

  {--------------------------------------------------------------------------}
  function InShort(c: char): Nibble;
  {--------------------------------------------------------------------------
    Diese Prozedur durchsucht das array of char 'Short' nach dem Zeichen 'c'
    und gibt den Index des Zeichens zurck, falls es gefunden wurde, oder den
    Wert 0, falls es nicht enthalten ist (Short[0] wird ignoriert).
   --------------------------------------------------------------------------}
  inline($58/		       {       POP   AX	     'c' holen		     }
	 $FD/		       {       STD	     Rckwrtszhlen	     }
	 $BF/Short+13/	       {       MOV   DI,offset Short+13		     }
	 $1E/		       {       PUSH  DS	     DS:Short vom Ende aus   }
	 $07/		       {       POP   ES	     aufrollen		     }
	 $B9/$0D/$00/	       {       MOV   CX,13   Anzahl der Zeichen	     }
	 $F2/$AE/	       {       REPNE SCASB   Suchen		     }
	 $74/$04/	       {       JE    found   Gefunden - Index zurck }
	 $31/$C0/	       {       XOR   AX,AX   Nicht gefunden - 0 zur. }
	 $EB/$03/	       {       JMP   cont    Weiter im Programm	     }
	 $89/$C8/	       { found:MOV   AX,CX   Index ins Rckgabereg.  }
	 $40);		       {       INC   AX	     Index in Bereich 1..13  }
			       { cont:		     Hier geht's dann weiter }

  {--------------------------------------------------------------------------}
  procedure Writeout;
  {--------------------------------------------------------------------------
    Diese Prozedur schreibt eventuell noch im Wiederholungspuffer befindliche
    Zeichen (jeweils das letzte Zeichen wird zurckgehalten, bis klar ist,
    ob es wiederholt werden soll oder nicht) in die Ausgabedatei und setzt
    den Puffer zurck. Dabei wird berprft, ob eine Wiederholung ntig ist,
    auerdem findet die eigentliche Kompression der Zeichen (short codes)
    hier statt.
   --------------------------------------------------------------------------}
  begin
    if ChRep=0 then
      exit;
    insh:=InShort(LastCh);
    if ChRep>1 then		       { Nur, falls berhaupt Wiederholungen }
      if ((insh>0) and (ChRep>3)) or (insh=0) then
	begin			       { Bestimmen, ob Wiederholung sinnvoll }
	  WriteNibble($E);	       { Wiederholungskennzeichen }
	  WriteNibble(ChRep-2);	       { Anzahl der Wiederholungen }
	  ChRep:=1;		       { Nur noch einmal ausgeben }
	end;
    if insh>0 then		       { Short code fr dieses Zeichen? }
      for i:=1 to ChRep do	       { Short codes knnen bis zu dreimal }
	WriteNibble(insh)	       { ohne Kennzeichen wiederholt werden }
    else
      begin
	WriteNibble($F);		  { ASCII-Kennzeichen }
	WriteNibble(ord(LastCh) and $0F); { Zeichencode }
	WriteNibble(ord(LastCh) div 16);
      end;
    ChRep:=0;			       { Wiederholungen vergessen }
  end;

  {--------------------------------------------------------------------------}
  procedure WriteComp(c: char);
  {--------------------------------------------------------------------------
    Diese Prozedur schreibt das Zeichen 'c' in die Ausgabedatei. Intern wird
    das Zeichen dabei zuerst zwischengespeichert, um eventuelle Wiederholungen
    erkennen zu knnen.
   --------------------------------------------------------------------------}
  begin
    if (c=LastCh) and (ChRep<17) then { Gleiches Zeichen wieder,max. 17 Wdh. }
      inc(ChRep)
    else
      begin
	Writeout;		       { Zeichen im Repeat-Buffer schreiben }
	LastCh:=c;		       { zu schreibendes Zeichen in Buffer }
	ChRep:=1;		       { Momentan nur einmal wiederholen }
      end;
  end;

begin
p:=3;				       { Erste Zeile ab 3.Zeichen durchsuchen }
pnum:=$FFFF;			       { Noch keine Seitennumer bekannt }
UpPage:=0;			       { Noch keine keine vorgehende Seite }
forcedpage:=false;                     { Kein Autoumbruch stattgefunden }
repeat
{ Diese Schleife wird in Seitenverkettungen fr jede Seite einmal wiederholt.
  Dabei ist ab dem zweiten Durchlauf bereits eine Seitennumer ermittelt
  worden, so da 'pnum' usw. schon Werte besitzen }
  repeat
    if pnum=$FFFF then		       { Falls Seitennumer noch nicht bekannt }
      repeat
	ScanWhite(s,p);		       { Erst Leerzeichen vorher abscannen }
	pnum:=ScanPage(s,p,c,true);    { Versuchen,eine Seitennummer zu lesen }
	if (pnum=$FFFF) and (p>length(s)) then
	  begin			       { Keine Nummer,und Zeilenende erreicht }
	    ReadLine(s);	       { Neue Zeile lesen }
	    p:=1;		       { Scannen ab erstem Zeichen }
	    newline:=true;	       { Kennzeichen: neue Zeile gelesen }
	  end
	else
	  newline:=false;
      until not newline;	       { Wiederholen,falls neue Zeile gelesen }
    inc(p);			       { Folgzeichen (evtl ',') bergehen }
    if pnum=$FFFF then		       { Ungltige Seitenzahl? }
      error('Invalid page number')     { Dann Fehlermeldung }
    else
      if pass=2 then		       { Korrekte Seitenzahl: }
{ Im zweiten Durchlauf: }
	with PageList[pnum] do	       { Seitenverzeichnis-Eintrag setzen }
	  begin
	    pos:=FilePos(f);	       { Anfangsposition der Seite in Datei }
	    l:=pos and $FF;	       { Anfangsposition in 3 Bytes aufteilen }
	    m:=(pos div 256) and $FF;
	    h:=(pos div 65536) and $FF;
	  end;
    if c=','then		       { Weitere Seitennummern? }
      pnum:=$FFFF;                     { Dafr sorgen, da sie gelesen werden }
  until c<>',';			       { Komma zeigt: noch mehr Nummern da }

  line:=0;                             { Noch keine Textzeilen }
  ButtCnt:=0;			       { Noch keine Buttons gefunden }
  ByteCnt:=0;			       { Seitenpuffer noch leer }
  FirstButton:=1;                      { default: Start bei Button links oben }
  WriteNow:=false;		       { Nchstes Nibble noch nicht schreiben }
  if forcedpage then                   { Vorhergehende Seite: Autoumbruch? }
    begin
      if pass=2 then
{ Im zweiten Durchlauf... }
        for i:=1 to HeadSpace do       { Dann so viele CR-0-Nibbles an den An-}
          WriteNibble($0);             { fang setzen, wie als Kopf gewnscht }
      inc(line,HeadSpace);	       { Kopfzeilen werden mitgezhhlt }
    end;
  repeat
    repeat
      ReadLine(s);		       { Eine Zeile einlesen }
    until (not forcedpage) or (s<>''); { Leerzeilen nach Umbruch bergehen }
    forcedpage:=false;                 { Standard: kein automatischer Umbruch }
    if (length(s)>2) and (s[1]=c_markers[3]) and (s[2]=c_markers[3]) then
      case upcase(s[3]) of
        'B': begin                   { B = Bedingter Seitenumbruch }
               p:=4;                 { Zeiger hinter Marke }
               ScanWhite(s,p);       { Parameter suchen }
               ref:=ScanNum(s,p,c);  { Parameter einlesen }
               if ref>scr_height-HeadSpace-FootSpace then
                                     { Ungltiger Parameter? }
                 error('Invalid page break value')
               else                  { gltig: }
                 if (line+ref>scr_height-FootSpace) and (version<6) then
                                     { Wenn nicht 'ref' Zeilen auf Seite }
                   line:=scr_height-FootSpace;
                                     { Umbruch erzwingen }
               ReadLine(s);          { Zeile berlesen }
             end;
      end;
    endpage:=(length(s)>=1) and (s[1]=c_markers[2]);
                                       { Feststellen, ob Seitenendmarke }
    ignorel:=endpage;                  { Endmarken ignorieren }
    if endpage and (version>=6) and (length(s)>=2) and (s[2]=c_markers[1]) then
                                       { Erzwungender Umbruch in "neu 2"? }
      endpage:=false;                  { Umbruch ignorieren }
    if autopage and (not endpage) and (line=scr_height-FootSpace) then
      begin                            { Keine Endmarke+Umbruch+Seite voll? }
        UnReadLine(s);                 { Dann gelesene Zeile "aufschieben" }
        endpage:=true;                 { Ende der Seite erzwingen }
        s:=c_markers[2]+c_markers[1];  { knstliche Umbruchmarke erzeugen }
        forcedpage:=true;              { als "knstlich" kennzeichnen }
      end;
    if not ignorel then                { Nur, wenn "normale" Zeile }
      begin
	p:=1;			       { Anfang beim ersten Zeichen der Zeile }
	inc(line);		       { Textfenster-Zeile weiterzhlen }
	col:=0;			       { Horizontale Anfangsposition }
	inbut:=false;		       { Nicht innerhalb eines Buttons }
	ChRep:=0;		       { Keine Wiederholung }
	LastCh:=#0;		       { Noch kein letztes Zeichen }
	while p<=length(s) do	       { Solange Zeilenende nicht erreicht }
	  begin
	    c:=s[p];		       { Aktuelles String-Zeichen }
            created:=false;            { Zeichen wurde "echt" gelesen }
            if (p+2<=length(s)) and (c=c_markers[3]) and (s[p+1]=c) then
                                       { Doppelter Button-Marker? }
              case upcase(s[p+2]) of   { Folgendes Zeichen auswerten }
                'H','N': begin
                           if version>=6 then
                             begin
                               if upcase(s[p+2])='H' then
                                 c:=#05  { "H": Hervorheben von Programmcode }
                               else
                                 c:=#06; { "N": Normal bis Zeilenende }
                               created:=true;
                                     { Sonderzeichen wurde umcodiert }
                             end
                           else
                             c:=#00; { Fr altes Format ignorieren }
                           p:=p+2;   { Zwei zustzliche Zeichen skippen }
                         end;
              end;
	    if c=c_markers[3] then     { "Button"-Marker? }
	      begin
		if inbut then	       { Falls gerade innerhalb Button }
		  begin
		    inc(p);	       { Zweiten Marker berspringen }
                    if s[p]=c_markers[3] then
                                       { Zweiter Marker doppelt? }
                      begin
                        inc(p);        { Auch noch berspringen }
                        if pass=2 then { Im zweiten Durchlauf... }
                          FirstButton:=ButtCnt;
                                       { Button als default merken }
                      end;
		    ref:=ScanPage(s,p,c,false); { Button-Seitennummer lesen }
		    if (ref=$FFFF) or (c<>c_markers[3]) then
				       { Auf Button mu eine Seite folgen }
		      error('Invalid button declaration');
                    if version<6 then  { Altes Format: }
                      begin
                        if pass=2 then { Button-Anfang im 2.Durchlauf merken }
                          begin
                            Button[ButtCnt].XEnd:=col;
                                       { Endspalte des Buttons merken }
                            Button[ButtCnt].ref:=ref;
                                       { Querverweis auch merken }
                          end;
                      end
                    else               { Neues Format: }
                      if pass=1 then
                        inc(occ[2])    { 1.Durchlauf: Button-Marker zhlen }
                      else
                        begin          { 2.Durchlauf: Button-Marker schreiben }
                          WriteComp(#02);
                          ButtonLP(ButtCnt-1)^:=ref;
                                       { Querverweis auch merken }
                        end;
		  end
		else		       { Falls auerhalb (=neuer Button) }
                  if pass=1 then       { 1. Durchlauf: }
                    begin
                      if version>5 then{ Neues Format: }
                        inc(occ[2])    { Button-Marker zhlen }
                    end
                  else                 { 2. Durchlauf: }
                    begin
                      inc(ButtCnt);    { Buttonzhler weiter }
                      if version<6 then{ Altes Format: }
                        begin
                          Button[ButtCnt].XPos:=col+1;
				       { Button-Anfangsspalte merken }
                          Button[ButtCnt].YPos:=line;
				       { Button-Zeile merken }
                        end
                      else
                        WriteComp(#02);{ Button-Marker schreiben }
                    end;
		inbut:=not inbut;      { Button inner-/auerhalb umschalten }
	      end
            else if c<>#00 then        { NULL-Zeichen: Ignorieren }
	      begin
		inc(col);	       { Cursorspalte weiterzhlen }
		if c=c_markers[4] then { "Quote"-Zeichen }
		  begin
		    inc(p);	       { Dann nchstes Textzeichen }
		    c:=s[p];
		    if (c>='@') and (c<='_')then
				       { Klartext-Control-Zeichen? }
		      dec(c,64);       { Ja: Auf Control-Code umrechnen }
		  end;		       { Ansonsten wrtlich zitieren }
                if (version>=6) and    { Im Format "neu 2"... }
                   ((c=#01) or (c=#02) or (c=#03) or (c=#05) or (c=#06)) and
                   not created then    { ...sind ^A,^B,^C,^E,^F reserviert }
	          c:=' ';	       { Durch Leerstelle ersetzen }
		if pass=1 then
{ Im ersten Durchlauf... }
		  inc(occ[ord(c)])     { Auftauchen der Zeichen zhlen }
		else
{ Im zweiten Durchlauf... }
		  WriteComp(c);	       { Zeichen komprimiert ablegen }
	      end;
	    inc(p);		       { Nchstes Zeichen im String }
	  end;
  	if (version<6) and (col>scr_width-scr_marg) then   
	    			       { berlange Zeile -> Fehler }
	  error('Line exceeds maximum width');
	if inbut then		       { "Offener" Button -> Fehler }
	  error('Invalid button declaration');
	if pass=2 then
{ Im zweiten Durchlauf... }
	  begin
	    Writeout;		       { Letztes Zeichen schreiben }
	    WriteNibble($0);	       { CR-Nibble (neue Zeile) schreiben }
	  end;
      end;
  until endpage;		       { Bis Endmarke erreicht }
  if (version<6) and (line>scr_height) then
                                       { Zu viele Zeilen? }
    error('Page exceeds maximum length');
  if (length(s)=2) and (s[2]=c_markers[1]) then
    begin			       { Folgt "ffnen-Marker? }
      EndSequ:=false;	               { Ja: Es folgen weitere Seiten }
{ In einer Seitenfolge werden die nicht-anspringbaren Seiten (Autolabels)
  erst nach dem zweiten Durchlauf zu physikalischen Seiten zugeordnet. So
  Weise ist eine weitreichende Freiheit fr absolute Positionierungen der
  jeweils ersten Seiten gegeben, d.h. Seitenfolgen knnen auf aufeinander-
  folgenden Seitennumern beginnen, falls ein externer Grund dies erfordert }
      if pass=2 then
{ Im zweiten Durchlauf... }
	begin
          str(RunningPage,s);	       { Label der nchsten Seite erzeugen }
          s:='@'+s;		       { Prfix fr automatische Labels }
          p:=1;			       { Label am Stringanfang }
          DnPage:=ScanPage(s,p,c,false);{ Label einscannen }
        end
      else
{ Im ersten Durchlauf... }
        pnum:=1;		       { Dummy-Seitennumer }
      inc(RunningPage);		       { Automatiklabel weiterzhlen }
    end
  else
    begin
      EndSequ:=true;		       { Andernfalls: keine Seiten folgen }
      DnPage:=0;		       { Default: PgDn nicht mglich }
    end;
  if version>=6 then                   { In THELP 2.0 Endmarke Control-A }
    if pass=1 then                     { Erster Durchlauf? }
      inc(occ[1])                      { Endmarke als Code zhlen }
    else
      WriteComp(#01);                  { Zweiter Durchlauf:Endmarke schreiben }
  if pass=2 then
{ Im zweiten Durchlauf... }
    begin
      Writeout;			       { Letztes Zeichen schreiben }
      if WriteNow then		       { Noch ein Nibble brig? }
	WriteNibble($0);	       { Dann schreiben (mit CR auffllen) }
      WriteByt($02);		       { Identifikation: Textseite }
      WriteInt(ByteCnt);	       { Lnge der Textseite }
      BlockWrite(File(f),Compress,ByteCnt);
				       { Schreiben des Puffers in die Datei }
      if ByteCnt>MaxSize then	       { Seite grer als die bisher grte? }
	MaxSize:=ByteCnt;	       { Dann als neue grte Seite merken }

      ByteCnt:=5;                      { Verknpfungen mind. 5 Bytes lang }
      Compress[0]:=0;		       { Vorbelegen der Verkettungsfelder }
      Compress[1]:=0;		       { (Standard: keine Verkettungen) }
      Compress[2]:=0;
      Compress[3]:=0;

{ Falls vorhanden, Verkettungen in der Form '<PgUp><PgDn>' hinter dem Seiten-
  endmarker einlesen (auch erlaubt: '<PgUp>' oder '<><PgDn>') }
      if (length(s)>2) and (s[2]='<')then { Nur, wenn berhaupt Verkettungen }
	begin
	  p:=3;			       { Dann hinter '<' anfangen }
	  ref:=ScanPage(s,p,c,false);  { Seitennummer lesen }
	  if ref<$FFFF then	       { gltige Zahl? }
	    begin
	      Compress[0]:=Lo(Ref);    { Ja: als PgUp-Referenz eintragen }
	      Compress[1]:=Hi(Ref);
	    end;
	  if (length(s)>p+2) and (c='>') and (s[p+1]='<') then
				       { Folgt noch ein Feld? }
	    begin
	      inc(p,2);		       { Dann auf vermuteten Anfang }
	      ref:=ScanPage(s,p,c,false); { Seitennumer lesen }
	      if ref<$FFFF then	       { gltige Zahl? }
		begin
		  Compress[2]:=Lo(Ref);{ Ja: als PgDn-Referenz eintragen }
		  Compress[3]:=Hi(Ref);
		end;
	    end;
	end
{ Falls Seitenverkettung erkannt worden ist, folgende und vorhergehende
  Seite eintragen und fr nchsten Seitendurch vorbereiten }
      else if (not EndSequ) or (UpPage>0) then
	begin
	  Compress[0]:=Lo(UpPage);     { Rckwrts: vorhergehende Seite }
	  Compress[1]:=Hi(UpPage);
	  Compress[2]:=Lo(DnPage);     { Folgende Seite eintragen }
	  Compress[3]:=Hi(DnPage);
	  UpPage:=pnum;		       { Nchste Seite rckwrts: Diese }
	  pnum:=DnPage;		       { Nchste Seite: Diese vorwrts }
	end;

      but_offset:=scr_marg;	       { Rand-Korrekturwert fr Buttons }

      Compress[4]:=Lo(ButtCnt);        { Anzahl der Buttons auf dieser Seite }
      if version>=6 then
{ --- Buttons im neuen Dateiformat (ab THELP 2.0): -------------------------- }
       begin
         Compress[5]:=Hi(ButtCnt);     { Button-Anzahl jetzt zwei Bytes }
         inc(ByteCnt);                 { Verknpfungsblock vergrern }
         for i:=1 to ButtCnt do
           begin                       { Button-Seiten bertragen }
             Compress[ByteCnt]:=Lo(ButtonLP(i-1)^);
             Compress[ByteCnt+1]:=Hi(ButtonLP(i-1)^);
             inc(ByteCnt,2);           { Verknpfungsfeld erweitern }
           end;
       end
      else
{ --- Buttons im alten Dateiformat (bis THELP 1.0): ------------------------- }
       begin
      { Tabelle zur Vertauschung der Buttons 1 und FirstButton: }
        for i:=2 to ButtCnt do         { Reihenfolge: Erst mal unverndert }
          ButtFlip[i]:=i;
        ButtFlip[1]:=FirstButton;      { Buttons 1 und FirstButton vertauscht }
        ButtFlip[FirstButton]:=1;

        for WriteButt:=1 to ButtCnt do { Gespeicherte Buttons ablegen }
          begin
            i:=ButtFlip[WriteButt];    { Nummer des Buttons in Button [] }
            Compress[ByteCnt  ]:=Button[i].YPos;
                                       { Koordinaten des Buttons ablegen }
            Compress[ByteCnt+1]:=Button[i].XPos+but_offset;
            Compress[ByteCnt+2]:=Button[i].XEnd+but_offset;
            Compress[ByteCnt+7]:=Lo(Button[i].ref);
                                       { Querverweis ablegen }
            Compress[ByteCnt+8]:=Hi(Button[i].ref);

       { Button, zu dem 'Cursor links' springt: }
            if i=1 then                { Vom ersten Button... }
              Compress[ByteCnt+3]:=ButtFlip[ButtCnt]
                                       { ...geht's links zum letzten }
            else
              Compress[ByteCnt+3]:=ButtFlip[i-1];
                                       { Ansonsten einfach einen zurck }

       { Button, zu dem 'Cursor rechts' springt: }
            if i=ButtCnt then          { Vom letzten Button... }
              Compress[ByteCnt+4]:=ButtFlip[1]
                                       { ...geht's rechts zum ersten }
            else
              Compress[ByteCnt+4]:=ButtFlip[i+1];
                                       { Ansonsten einfach einen weiter }

{ Fr die folgenden Zeilen mchte sich der Autor ganz herzlich bei allen
  entschuldigen, die versuchen, diesen Quellcode zu verstehen.
  Sie bestimmen die 'Cursor hoch/runter'-Verknpfung (die beiden Module sind
  ziemlich symmetrisch aufgebaut), wobei sie in den allermeisten Fllen den
  Erwartungen des Benutzers an die Cursorsteuerung (wo geht er wohl hin, wenn
  ich 'hoch' drcke?) gengen. Besonderes Augenmerk wurde dabei auf die Be-
  handlung spaltiger Button-Listen gelegt; Probleme gibt es allerdings noch
  bei Listen, bei denen die eine Spalte krzer ist als ihre Nachbarn }

       { Button, zu dem 'Cursor hoch' springt: }
            j:=i-1;                    { Suche beginnt beim Button davor }
            l:=i;                      { Standard: Button zu sich selbst }
            while (j>0) and (l=i) do   { Solange noch Buttons und erfolglos }
              begin
                if (Button[j].XPos<=Button[i].XEnd) and
                   (Button[j].XEnd>=Button[i].XPos) then
                  l:=j;                { Button im Bereich darber: nehmen }
                dec(j);                { Nchster Button }
              end;
             if l=i then               { Falls oberhalb nichts zu finden... }
               begin
                 j:=i-1;               { Suche beginnt mit Button davor }
                 while (j>0) and (Button[j].YPos=Button[i].YPos) do
                   dec(j);
                 Wrap:= j<1;           { Prfen, ob nach oben zurck }
                 if Wrap then          { Falls ja, zum ersten Button }
                   j:=ButtCnt;
                 line:=Button[j].YPos; { Zeile, in der gesucht wird }
                 col:=$FF;             { beste Spaltendifferenz: maximal }
                 while (j>0) and (Button[j].YPos=line) do
                   begin               { Alle Buttons in der Zeile prfen }
                     if abs(Button[i].XPos-Button[j].XPos)<col then
                                       { Horizontal nher als Minimum? }
                       begin
                         col:=abs(Button[i].XPos-Button[j].XPos);
                                       { Ja: Neues Minimum merken }
                         l:=j;         { Merken, welcher Button es ist }
                       end;
                     dec(j);           { Weiter zum nchsten Button }
                   end;
                 if Wrap then          { Spalte davor, falls umgeklappt }
                   begin
                     if (l>1) and (Button[l-1].YPos=line) then
                                       { Falls Button davor noch in Zeile }
                       dec(l)          { ...dann zu diesem }
                     else
                       l:=ButtCnt;     { Ansonsten zum letzten in der Zeile }
                   end;
               end;
            Compress[ByteCnt+5]:=ButtFlip[l];
                                       { Optimaler Button wird Verbindung }

       { Button, zu dem 'Cursor runter' springt: }
            j:=i+1;                    { Suche beginnt bei nchsten Button }
            l:=i;                      { Standard: Button zu sich selbst }
            while (j<=ButtCnt) and (l=i) do
                                       { Solange noch Buttons und erfolglos }
              begin
                if (Button[j].XPos<=Button[i].XEnd) and
                   (Button[j].XEnd>=Button[i].XPos) then
                  l:=j;                { Button im Bereich darber: nehmen }
                inc(j);                { Nchster Button }
              end;
             if l=i then               { Falls unterhalb nichts zu finden... }
               begin
                 j:=i+1;               { Suche beginnt wieder mit nchtem }
                 while (j<=ButtCnt) and (Button[j].YPos=Button[i].YPos) do
                   inc(j);
                 Wrap:= j>ButtCnt;     { Prfen, ob nach oben zurck }
                 if Wrap then          { Falls ja, zum ersten Button }
                   j:=1;
                 line:=Button[j].YPos; { Zeile, in der gesucht wird }
                 col:=$FF;             { beste Spaltendifferenz: maximal }
                 while (j<=ButtCnt) and (Button[j].YPos=line) do
                   begin               { Alle Buttons in der Zeile prfen }
                     if abs(Button[i].XPos-Button[j].XPos)<col then
                                       { Horizontal nher als Minimum? }
                       begin
                         col:=abs(Button[i].XPos-Button[j].XPos);
                                       { Ja: Neues Minimum merken }
                         l:=j;         { Merken, welcher Button es ist }
                       end;
                     inc(j);           { Weiter zum nchsten Button }
                   end;
                 if Wrap then          { Nchste Spalte, falls umgeklappt }
                   if (l<ButtCnt) and (Button[l+1].YPos=line) then
                                       { Falls Button danach noch in Zeile }
                     inc(l)            { ...dann zu diesem }
                   else
                     l:=1;             { Ansonsten zum ersten in der Zeile }
               end;
            Compress[ByteCnt+6]:=ButtFlip[l];
                                       { Optimaler Button wird Verbindung }
            inc(ByteCnt,9);            { Ausgabezeiger hinter Button-Block }
          end;
       end;

      WriteByt($03);		       { Identifikation: Verknpfung }
      WriteInt(ByteCnt);	       { Lnge des Verknpfungsblocks }
      BlockWrite(File(f),Compress,ByteCnt);
				       { Schreiben des Puffers in die Datei }
    end;
until EndSequ;                         { Wiederholen, falls Seitenfolge }
end;

{----------------------------------------------------------------------------}

begin
  writeln;
  writeln('HELPMAKE 1.21 -=- Borland(TM) Help File Compiler');
  writeln('written by Marcus Grber & Torsten Brand 1989-92');
  writeln;

  version:=6;                          { default: Neuestes Format erzeugen }

{ Kommandozeilenparser: }
  parnum:=1;                           { Los geht's beim ersten Parameter }
  namepar:=0;                          { Noch kein Namensparameter gelesen }
  infile:='';                          { Keine Namen gelesen }
  outfile:='';
  TypeID:=-1;                          { Keine Typ-bersteuerung }
  repeat
    par:=ParamStr(parnum);             { Parameter lesen }
    if (length(par)>1) and ((par[1]='-') or (par[1]='/')) then
      begin                            { Switches? }
        case UpCase(par[2]) of         { Switches auswerten }
          'T': if length(par)>2 then
                 case par[3] of
                   '0': version:=4;    { /T0: Alte Version }
                   '1': version:=5;    { /T1: Neue Version (THELP 1.0) }
                   '2': version:=6;    { /T2: Neue Version 2 (THELP 2.0) }
                   else begin
                          writeln('Unknown format: /T',par[3]);
                          halt(1);     { Abbruch mit Fehlermeldung }
                        end;
                 end
               else
                 version:=5;           { default: /T wie /T1 }
          'X': if length(par)>2 then   { /Xnnn: Typcode bersteuern }
                 val(copy(par,3,3),TypeID,k);
          else begin
                 writeln('Invalid option: -',par[2]);
                 halt(1);              { unbekannt: Fehlermeldung/Abbruch }
               end;
        end;
      end
    else if par<>'' then
      begin
        inc(namepar);                  { Parameter zhlen }
        if namepar=1 then              { Erster Parameter ist Eingabedatei }
          infile:=par
        else if namepar=2 then         { Zweiter Parameter ist Ausgabedatei }
          outfile:=par;
      end;
    inc(parnum);                       { Nchster Paramter }
  until (par='');                      { Wiederholen, bis keine Parameter }
  if infile='' then                    { Kein Eingabefile angegeben? }
    begin
      writeln('Usage: HELPMAKE [options] <source> [<helpfile>]');
      writeln('options: -t0    create "old" file format');
      writeln(     #09' -t1    create "new" file format (THELP 1.0)');
      writeln(     #09' -t2    create "new 2" file format (THELP 2.0)');
      writeln(     #09' -xnnn  force type code to nnn');
      halt(1);
    end;
  if outfile=''then                    { Kein Ausgabefile? }
    outfile:=AddExt(infile,'HLP');     { default: textfile.HLP }

  GetTimeRec(time);		       { Startzeit des Programms merken }
  HeapError:=@HeapErrorHandler;        { Behandlung von Speicher-voll-Fehlern }
  assign(inp[1],infile);	       { Main file ffnen }
  {$I-} reset(inp[1]); {$I+}           { Zum Lesen ffnen }
  if IOResult<>0 then                  { Fehlschlag? }
    begin
      writeln('Cannot open input file.');
      halt(2);                         { Mit Fehlermeldung abbrechen }
    end;
  UnRead:=false;                       { Puffer/zurckgestellte Zeilen leeren }
  assign(f,outfile);                   { Ausgabedatei erffnen }
  rewrite(f);
  new(Idx);                            { Ein Pseudoelement am Anfang erzeugen }
  Idx^.next:=NIL;                      { Mehr gibt's noch nicht }
  Idx_n:=0;                            { Noch keine Eintrge im Index }
  PageNumber:=0;                       { Noch keine Seiten vorhanden }
  FreePage:=1;                         { Seite fr nchsten Label }
  MaxSize:=0;                          { Maximale Seitelnge initialisieren }
  for i:=0 to 255 do                   { Zhler fr die Zeichenhufigkeit }
    occ[i]:=0;                         { auf 0 setzen }
  for k:=0 to max_pages do             { Alle Seiten anfangs undefiniert }
    PageList[k]:=NoPage;
  for k:=0 to HashConst-1 do           { Noch sind alle Hash-Teillisten leer }
    HashList[k]:=NIL;
  GetMem(ButtonL,$8000);               { Liste fr Button-Verweise }

{ Defaultwerte fr die diversen Parameter: }
  DefaultPage:=0;                      { Standardseite: Undefiniert }
  IndexPage:=1;                        { Standardseite fr Index: 1 }
  Title:=def_title;                    { Standardtitel annehmen }
  scr_width:=def_width;                { Standardmae des Bildschirms }
  scr_height:=def_height;
  case_sensitive:=false;               { Standard: Gro-/Kleinschreibung egal }
  head:=stdhead;                       { Standard-Dateikopfbelegung }
  case version of                      { Versionen unterscheiden }
    4: begin
         hdrsize:=11;                  { Gre des alten Dateikopfes }
         scr_marg:=1;                  { Rand bei der alten Version }
       end;
    5: begin
         hdrsize:=18;                  { Gre des neuen Dateikopfes }
         scr_marg:=2;                  { Rand bei der neuen Version }
       end;
    6: begin
         hdrsize:=18;                  { Gre des neuen Dateikopfes 2 }
         scr_marg:=1;                  { Rand bei der neuen Version 2 }
       end;
    end;
  ProgCode:=0;                         { Standard-Programmcode }

{ Hauptschleife fr die Durchlufe 1 und 2 }
  for pass:=1 to 2 do
    begin
      writeln('Pass ',pass,'...');
      FileLevel:=1;                    { Main file }
      reset(inp[FileLevel]);           { Anfang der Eingabedatei anspringen }
      linenum[FileLevel]:=0;           { Zeilenzhlung zurck }
      FoundErrors:=0;                  { Noch keine Fehler gefunden }
      RunningPage:=0;                  { Automatiklabels zurcksetzen }
      c_markers:=def_markers;          { Standardmarker setzen }
      AutoPage:=false;                 { Standard: kein automatischer Umbruch }
      HeadSpace:=0;                    { Oberer Rand: 0 Zeilen }
      FootSpace:=0;                    { Unterer Rand: 0 Zeilen }
      repeat
        ReadLine(s);                   { Eine Zeile aus der Datei lesen }
        if (s='') or (s[1]=' ')then    { Leerzeilen oder eingerckte Strings }
          s:='@';                      { ...werden wie Kommentare behandelt }
        p:=2;                          { Ab zweitem Zeichen }
        ScanWhite(s,p);                { ...Leerstellen berspringen }
{ Decodierung der einzelnen Anweisungen }
        case UpCase(s[1]) of           { Unterscheidung nach 1. Zeichen }
          '@': ;                       { '@' - Kommantar wird ignoriert }
          '$': begin                   { '$' - Include file }
                 if FileLevel=MaxFileLevel then
                                       { Zu viele Include-Files? }
                   critical('Include buffer full');
                                       { Abbruch mit Fehlermeldung }
                 s:=copy(s,p,80);      { Parameter holen }
                 if s[1]='*'then       { Dateiname beginnt mit '*'? }
                   s:=AddExt(GetFileName(inp[FileLevel]),copy(s,3,3));
                                       { Dann Namen der enthaltenden Datei plus
                                         Extension hinter '*.' benutzen }
                 inc(FileLevel);       { Schachtelungstiefe erhhen }
                 assign(inp[FileLevel],s); { Dateinamen setzen }
                 {$I-} reset(inp[FileLevel]); {$I+}
                                       { Datei zum Lesen erffnen }
                 if IOResult in [1..2] then
                                       { Datei nicht gefunden? Abbruch! }
                   begin
                     dec(FileLevel);   { Auf alte Schachtelungsebene zurck }
                     critical('Include file '''+s+''' not found');
                   end;
		 LineNum[FileLevel]:=0;{ Zeilenzhlung zurck }
	       end;
	  'M': c_markers:=copy(s,p,4); { 'M' - Markerzeichen neu setzen }
	  'T': begin
                 Title:=copy(s,p,40);  { 'T' - Titel der Datei definieren }
                 if (copy(Title,1,5)<>'TURBO') and (version>=6) then
                   error('THELP will reject title not beginning with TURBO');
               end;                    { THELP 2.0: Titel mu TURBO... sein }
	  'P': if pass=2 then	       { 'P' - Programmcode setzen }
		 begin
		   ref:=ScanNum(s,p,c); { Zahl suchen und decodieren }
		   if ref<256 then	{ Gltige Zahl }
		     ProgCode:=ref;	{ Dann neuen Code annehmen }
		 end;
	  'D': if pass=2 then	       { 'D' - Standardseite setzen }
		 begin
		   ref:=ScanPage(s,p,c,false); { Seite suchen und decodieren }
		   if ref<=PageNumber then { Gltige Seitenzahl }
		     DefaultPage:=ref	{ Dann neue Standardseite annehmen }
		   else
		     error('Invalid page number');
		 end;
	  'X': if pass=2 then	       { 'X' - Indexseite setzen }
		 begin
		   ref:=ScanPage(s,p,c,false); { Seite suchen und decodieren }
		   if ref<=PageNumber then { Gltige Seitenzahl }
		     IndexPage:=ref    { Dann neue Indexseite annehmen }
		   else
		     error('Invalid page number');
		 end;
	  'S': begin                         { Bildschirmformat }
		 scr_width:=ScanNum(s,p,c);  { Bildschirmbreite holen }
		 inc(p);		     { Trennzeichen berspringen }
		 scr_height:=ScanNum(s,p,c); { Bildschirmhhe holen }
		 if (scr_width-scr_marg<1) or (scr_width>78) or
		    (scr_height<1) or (scr_height>24) then
					     { Ungltige Parameter }
		   begin
		     error('Invalid size parameters');
					     { Fehlermeldung }
		     scr_width:=def_width;   { Standardparameter aktivieren }
		     scr_height:=def_height;
		   end;
	       end;
          'F': begin                   { 'F' - Umbruch-Rand setzen }
                 ref:=ScanNum(s,p,c);  { Kopfrand-Parameter suchen }
                 if ref<$FFFF then     { Zahlenwert vorhanden? }
                   if ref<scr_height then
                     HeadSpace:=ref    { Gltig? Dann neuen Rand setzen }
                   else                { Ungltig: Fehlermeldung }
                     error('Invalid frame value');
                 inc(p);               { Komma berlesen }
                 ref:=ScanNum(s,p,c);  { Furand-Parameter suchen }
                 if ref<$FFFF then     { Zahlenwert vorhanden? }
                   if ref<scr_height-HeadSpace then
                     FootSpace:=ref    { Gltig? Dann neuen Rand setzen }
                   else                { Ungltig: Fehlermeldung }
                     error('Invalid frame value');
               end;
	  'O': begin		       { 'O' - Optionen setzen }
		 repeat
		   s1:=ScanCom(s,p,c); { Option bis Komma lesen }
		   inc(p);	       { Komma berlesen }
		   UpStr(s1);	       { Option in Grobuchstaben umwandeln }
		   if s1>''then	       { Falls berhaupt eine Option... }
		     if (s1='CASE') or (s1='NOCASE') then
				       { Optionen fr 'Case sensitivity' }
		       case_sensitive:=(s1='CASE')
				       { Flag entsprechend setzen }
                     else if (s1='PAGE') or (s1='NOPAGE') then
                                       { Optionen fr 'Seitenumbruch' }
                       AutoPage:=(s1='PAGE') and (version<6)
                                       { Flag entsprechend setzen }
		     else
		       error('Invalid option '''+s1+'''');
				       { Fehler: ngltige Option }
		 until c<>',';
	       end;
	  'I': begin
		ref:=ScanPage(s,p,c,false); { Seitennumer suchen, eventuell
					      Label neu anlegen }
		if pass=1 then
{ Im ersten Durchlauf... }
		 begin
{ Indexbegriff in die verkettete Liste einsortieren. Dabei wird eventeull
  auch ein neuer Label angelegt und einer Seite zugeordnet, da die Labels
  nach dem ersten Durchlauf vorhanden sein mssen. }
		   if ref=$FFFF then	      { Ungltige Seitennumer }
		     error('Invalid page number');
				       { Fehlermeldung }
		   if ForwardRef then  { Label noch undefiniert }
		     error('Forward references not allowed in index entries');
		   ScanWhite(s,p);     { Danach Leerstellen berspringen }
		   newent:=copy(s,p,32);
				       { Eintrag: 32 Zeichen (hinter Ref.) }
		   if not case_sensitive then
				       { Falls Gro-/Kleinschreibung egal... }
		     UpStr(newent);    { ...in Grobuchstaben umwandeln }
		   ptr:=Idx^.next;     { Suche beginnt beim zweiten Element }
		   optr:=Idx;	       { Vorhergehendes: Erstes Element }
		   while (ptr<>NIL) and (ptr^.entry<newent) do
				       { Bis zum Ende der Liste oder bis zur }
		     begin	       { passenden Position suchen }
		       optr:=ptr;
		       ptr:=ptr^.next;
		     end;
		   if (ptr<>NIL) and (ptr^.entry=newent) then
				       { Identischen Eintrag gefunden? }
		     error('Redefinition of index entries prohibited')
				       { Fehler, ignorieren }
		   else		       { Ansonsten neu eintragen }
		     begin
		       New(ptr2);      { Platz fr einen Indexeintrag }
		       ptr2^.next:=ptr; { Folgendes Element eintragen }
		       optr^.next:=ptr2;{ Zeiger auf dieses im vorhergehenden }
		       ptr2^.ref:=ref; { Querverweis Seite eintragen }
		       ptr2^.entry:=newent;
		       inc(Idx_n);     { Indexeintrge zhlen }
		     end;
		 end
		else
{ Nur im zweiten Durchlauf... }
		  if ref>PageNumber then { Ungltige Seitenzahl? }
		    error('Invalid page number');
	       end;
	  else			       { Andere Zeichen: }
	    if s[1]=c_markers[1] then  { Blockffnungsmarker }
	      if UpCase(s[2])='P' then { 'P' - Seitenbeschreibung }
		ProcessPage	       { Dann Seite bearbeiten }
	      else
		error('Unknown block specifier')
	    else
	      error('Unknown command');
	end;
	if eof(Inp[FileLevel]) then    { Ende der akutellen Datei }
	  begin
	    close(Inp[FileLevel]);     { Datei schlieen }
	    dec(FileLevel);	       { Dann zurck zur bergeordneten Datei }
	  end;
      until FileLevel=0;	       { Hauptschleife bis Ende Main File }

      if pass=1 then
{ Nach dem ersten Durchlauf... }
	begin
{ Eintragen der automatischen Labels }
	  for k:=0 to Integer(RunningPage)-1 do
	    begin
	      str(k,s);		       { Label der Seite erzeugen }
	      s:='@'+s;		       { Prfix fr automatische Labels }
	      p:=1;		       { Anfangen am Stringanfang }
	      ref:=ScanPage(s,p,c,true); { Label einscannen/neu erzeugen }
	    end;
{ Herausfinden der dreizehn hufigsten Buchstaben und Abspeichern im Feld
  Short[1..13] - wird fr Textkompression im zweiten Durchlauf bentitgt }
	  i:=1;
	  repeat
	    maxocc:=-1;		       { Maximum auf kleinstmglichen Wert }
	    for j:=0 to 255 do	       { Alle Zeichen abklopfen }
	      if occ[j]>maxocc then    { Hufiger als bisheriges Maximum }
		begin
		  maxocc:=occ[j];      { Maximum merken }
		  maxocc_i:=j;	       { ...und wo es vorkommt }
		end;
	    occ[maxocc_i]:=0;	       { Bei nchstem Durchlauf vergessen }
	    if maxocc=0 then	       { Falls keine weiteren Zeichen im Text }
	      maxocc_i:=32;	       { short codes mit Spaces auffllen }
	    short[i]:=chr(maxocc_i);   { Zeichen fr short codes merken }
	    inc(i);		       { Nchster Buchstabe }
	  until i=14;		       { 13 hufigste Zeichen finden }
{ Ablegen der Indexbegriffe (reduzierte Speicherung - da die Begriff sor-
  tiert sind, reicht es aus, die Differenzen am Wortende zu speichern) }
	  IndexLength:= length(title)+2	   { Titel plus EOF/NUL }
		       +length(ident)+1	   { ID-String plus NUL }
		       +hdrsize		   { Kopfinformationen }
		       +14		   { "Short char"-Tabelle }
		       +5+(PageNumber+1)*3 { Seitenverzeichnis }
		       +3;		   { 3 Bytes Indexkopf noch bergehen }
				       { Index folgt nach Dateikopf und Seiten-
					 verzeichnis }
	  Seek(f,IndexLength);	       { Indexstart anspringen }
	  WriteInt(Idx_n);	       { Anzahl der Indexbegriffe }
	  ptr:=Idx^.next;	       { Anfang beim zweiten Begriff }
	  newent:='';		       { Bisher noch kein vorheriger Eintrag }
	  while ptr<>NIL do	       { Solange noch Begriffe vorhanden }
	    begin
	      i:=1;		       { Vergleich beginnt mit erstem Zeichen }
	      while (i<8) and (i<=length(newent)) and (newent[i]=ptr^.entry[i]) do
		inc(i);		       { Anzahl der bereinstimmenden Zeichen
					 (maximal 7 Stck) }
	      newent:=ptr^.entry;      { Aktuellen Eintrag holen }
	      WriteByt((i-1)*32+length(newent)-i+1);
				       { Codieren des Lngenbytes:
					  Bit 0..4: Lnge des Wortrestes
					  Bit 5..7: Lnge unvernderter Start }
	      for j:=i to length(newent) do
				       { Wortrest ab Zeichen i abspeichern }
		WriteByt(byte(newent[j]));
	      WriteInt(ptr^.ref);      { Seitenverweis ablegen }
	      ptr:=ptr^.next;	       { Zum nchsten Eintrag }
	    end;
	  IndexLength:=FilePos(f)-IndexLength;
				       { Lnge des Indexverzeichnisses }
	end;
{ Abbruch, falls Fehler in einem Durchlauf gefunden }
      if (FoundErrors>0) then	       { Fehler gefunden? }
	begin
	  writeln;
	  writeln(' ',FoundErrors,' Error(s) detected during pass ',pass,'.');
				       { Ja: Meldung ausgeben }
	  halt(1);		       { Fertig mit Fehlercode }
	end;
    end;

  Seek(f,0);			       { Anfang der Datei anspringen }
{ Dateititel ablegen }
  s:=Title+#$00#$1A+Ident+#$00;	       { Endmarke/ID-String an Titel hngen }
  for i:=1 to length(s) do	       { Hilfsdateititel ausgeben }
    WriteByt(ord(s[i]));

{ Dateikopf erzeugen und ablegen }
  if version=4 then		       { Alte Hilfsdatei-Version? }
    Head[1]:=2			       { Dann alten Versionscode eintragen }
  else
    if version=5 then                  { Neue Hilfsdatei-Version? }
      Head[1]:=4                       { Dann "neuer Code 1" (THELP 1.0) }
    else
      Head[1]:=5;                      { Sonst "neuer Code 2" (THELP 2.0) }
  if TypeID>-1 then Head[1]:=TypeID;   { Evtl. Versionscode bersteuern }
  Head[2]:=ProgCode;		       { Programmcode eintragen }
  if version=4 then                    { Bedeutung des Bytes bei Head[4] ist }
    Head[4]:=$14                       { unbekannt (Wert empirisch ermittelt }
  else
    Head[4]:=$09;
  Head[6]:=0;			       { Optionsbyte }
    if case_sensitive then	       { Bit 3 gesetzt, wenn 'case sensitive' }
      Head[6]:=Head[6] or $04;
  Head[8]:=Lo(IndexPage);	       { Indexseite eintragen }
  Head[9]:=Hi(IndexPage);
  Head[10]:=Lo(MaxSize);	       { Maximale Seitenlnge eintragen }
  Head[11]:=Hi(MaxSize);
  Head[12]:=scr_height;		       { Zeilen pro Bildschirm }
  Head[13]:=scr_width;		       { Spalte pro Bildschirm }
  Head[14]:=scr_marg;		       { Rand links }
  for i:=1 to 7 do		       { Identischen Teil des Kopfs ausgeben }
    WriteByt(Head[i]);
  if version=4 then		       { Alte Version: }
    begin
      for i:=12 to 14 do	       { Dann nur ausgewhlte Felder in Kopf }
	WriteByt(Head[i]);
      WriteByt(Head[18]);
    end
  else				       { Neue Version: }
    for i:=8 to 18 do		       { Dann ganzen Kopf schreiben }
      WriteByt(Head[i]);
  Short[0]:=#00;		       { Erster "short code" ist immer CR/LF }
  for i:=0 to 13 do		       { 14 "short code"-Zeichen ausgeben }
    WriteByt(ord(Short[i]));

{ Seitenverzeichnis ablegen }
  WriteByt($01);		       { Identifikation: Seitenverzeichnis }
  WriteInt((PageNumber+1)*3+2);	       { Lnge: 3 Bytes/Seite+Seitenzahlwort }
  WriteInt(PageNumber+1);	       { Seitenzahl }
  if DefaultPage=0 then		       { Keine Standardseite definiert? }
    DefaultPage:=IndexPage;	       { Dann Indexseite als Standardseite }
  undefined:=0;                        { Noch keine undefinierten Seiten }
  WriteTrip(NoPage);                   { Seite 0 immer undefiniert }
  for k:=1 to PageNumber do            { Alle Seiten durchgehen }
    if PageList[k].H=$FF then          { Undefinierte Seite? }
      begin
        WriteTrip(PageList[DefaultPage]);{ Dann Standardseite einsetzen }
        inc(undefined);                  { Undefinierte Seiten zhlen }
      end
    else
      WriteTrip(PageList[k]);          { Ansonsten Seitenpositon angeben }

  WriteByt($04);		       { Identifikation fr Indexliste }
  WriteInt(IndexLength);	       { Indexlnge schreiben }

  close(f);			       { Ausgabedatei schlieen }

  GetTimeRec(time2);		       { Schluzeit merken }

{ Schlubemerkungen zur Datei ausgeben }
  writeln;
  writeln(' Help file name: ',Title,'  (ID code #',ProgCode,')');
  TimeDiff(time2,time, time);	       { time:=time2-time }
  with time do
    writeln(' Compilation time:  ',hour,' ',minute,''' ',second,'"');
  writeln(' File statistics:');
  writeln('  Pages:         ',PageNumber);
  writeln('  Undef''d pages: ',undefined);
  writeln('  Max page size: ',MaxSize,' Bytes');
  writeln('  Keywords:      ',Idx_n);
  write	 ('  Short code chars are ''');
  for i:=1 to 13 do
    if Short[i]>=' 'then	       { Normaler ASCII-Code? }
      write(Short[i])		       { Einfach ausgeben }
    else
      write(c_markers[4],chr(ord(Short[i])+64));
				       { Steuerzeichen: Mit Marker ausgeben }
  writeln('''');
  halt(0);			     { Fertig, keine Fehler }
end.
