{-----------------------------------------------------------------------------

        HELPREAD 1.20 -=- Turbo Helpfile-DeCompiler (THELP-Format)

        zu compilieren mit TurboPascal 4.0/5.0/5.5/6.0

        written by Marcus Grber 1991P
	Special thanks to Torsten Brand

-----------------------------------------------------------------------------}

{$IFNDEF VER40} {$A+,E+,O-} {$ENDIF}  { Neue Compileroptionen nur ab 5.0 }
{$B-,F-,I+,L+,N-,R-,S-,V-}
{$M 8192,32768,655360}

program ReadHelp;

uses Dos;

const
  LabelLen=16;
  ident: string='$*$* &&&&$*$'#0;

  c_markers: string	  = '##~`';
  SpecialSet: set of char = [#1..#31,'#','~','`'];

  max_pages = 9999;

type
  PageRec = record
	      L,M,H: byte;
	    end;
  LabelStr = string[LabelLen];
  LabelRecPtr=^LabelRec;
  LabelRec = record
               Lab:  LabelStr;
               Page: word;
               Next: LabelRecPtr;
             end;
  IndexPtr = ^IndexRec;
  IndexRec = record
	       entry: string[32];
	       ref:   word;
	       next:  IndexPtr;
	     end;
  Nibble  = $0..$F;

const
  NoPage:PageRec=(L:$FF;M:$FF;H:$FF);

var
  stderr:     text;
  f:	      file of byte;
  headf,out:  text;
  pg,p2:      word;
  fptr:	      longint;
  cnt:	      word;
  p,p_save:   IndexPtr;
  p_last:     IndexPtr;
  parnum:     byte;
  namepar:    byte;
  par:        string;
  i:	      byte;
  j:          integer;
  infile:     string;
  outfile:    string;
  Head:	      array [1..18] of byte;
  headlen:    byte;
  vers:	      byte;
  TypeID:     byte;
  Short:      array [0..13] of char;
  PageDir:    array [0..max_pages] of PageRec;	    { Ein 30-Kilobyte-Array! }
  Pages:      word;
  Idx:	      IndexPtr;
  Title:      string[40];
  IndexPg:    word;
  scr_marg:   byte;
  scr_height: byte;
  scr_width:  byte;
  but_offset: byte;
  Options:    byte;
  ProgCode:   byte;
  p_PgUp:     word;
  p_PgDn:     word;
  LabelPref:  string[12];
  IndexLabels:boolean;
  UpLabels:   boolean;
  SplitSize:  word;
  PageCount:  word;
  FileCount:  byte;
  LabelList:  LabelRecPtr;

{$I HELPTOOL.INC}

{----------------------------------------------------------------------------}
{$F+} function HeapErrorHandler(size: word): Integer; {$F-}
{----------------------------------------------------------------------------
  Diese Funktion dient der Behandlung von Heap-Fehlern. Sie sorgt dafr, da
  das Programm im Falle eines Speicherberlaufs geordnet mit einer Fehler-
  meldung abgebrochen wird.
 ----------------------------------------------------------------------------}
begin
  if size>0 then                        { size=0 ist kein Fehler (Turbo 6.0) }
    begin
      writeln(#13'Insufficent memory - program terminated.');
      halt(1);
    end;
end;

{----------------------------------------------------------------------------}
procedure Get_Header;
{----------------------------------------------------------------------------
  Die folgende Prozedur liest den Kopf der Hilfsdatei (Titel, Kurzzeichen-
  tabelle usw.). Dabei wird auch versucht, Nicht-Hilfsdateien abzufangen (z.B.
  anhand des Identifikationsstrings). Auerdem erfolgt einer Unterscheidung der
  Hilfsdateiversionen (alte oder neue).
 ----------------------------------------------------------------------------}
var
  i: byte;
  c: char;
begin
  Title:='';			       { Titelstring lschen }
  repeat
    read(f,byte(c));		       { Ein Zeichen holen }
    if (c<>#0) and (length(Title)<40) then
				       { Noch keine Endmarke und noch Platz? }
      ConcatChar(Title,c);	       { Zeichen an Titelstring anfgen }
  until (c=#0) or (length(Title)=40);  { Bis Endmarke oder zu langem Titel }
  read(f,byte(c));		       { Ein Zeichen berlesen ($1A) }
  for i:=1 to length(ident) do	       { Identifikationsstring einlesen }
    begin
      read(f,byte(c));		       { Ein Zeichen holen }
      if c<>ident[i] then	       { entspricht nicht dem,was kommen soll }
	begin
	  writeln('Incompatible file format');
	  halt(1);
	end;
    end;
  read(f,TypeID);           { Versionsidentifikation lesen }
  if TypeID=2 then                     { TPascal 4.0 ("alte Fassung") }
    begin headlen:=10; vers:=4; end    { Header: 10 Bytes, Version: 4 }
  else if TypeID=4 then                { THELP 1.0 ("neue Fassung")? }
    begin headlen:=17; vers:=5; end    { Header: 17 Bytes, Version: 5 }
  else                                 { THELP 2.0 ("neue Fassung 2")? }
    begin headlen:=17; vers:=6; end;   { Header: 17 Bytes, Version: 6 }
  for i:=1 to headlen do
    read(f,head[i]);		       { Kopfbytes einlesen }
  for i:=0 to 13 do
    read(f,byte(Short[i]));	       { Kurzzeichentabelle einlesen }
{ Header auslesen (alle Versionen) }
  ProgCode:=head[1];		       { Programmcode }
  Options:=head[5];		       { Optionsbyte (case sensitivity) }
{ Header auslesen (versionsabhngig) }
  if vers=4 then		       { In alten Dateien... }
    begin
      IndexPg:=100;		       { Indexseite immer 100 }
      scr_height:=head[7];	       { Zeilen pro Schirm }
      scr_width:=head[8];	       { Spalten pro Schirm }
      scr_marg:=head[9];	       { Randbreite holen }
    end
  else				       { In neuen Dateien... }
    begin
      IndexPg:=head[7]+head[8]*256;    { Indexseite holen }
      scr_height:=head[11];	       { Zeilen pro Schirm }
      scr_width:=head[12];	       { Spalten pro Schirm }
      scr_marg:=head[13];	       { Randbreite holen }
    end;
  but_offset:=scr_marg;		       { Spalten-Korrekturwert fr Buttons }
end;

{----------------------------------------------------------------------------}
function Ref(p: PageRec): longint;
{----------------------------------------------------------------------------
  Diese Funktion wandelt eine 3-Byte-Zahl (aus dem Seitenverzeichnis) in einen
  longint-Wert um, so da damit gerechnet werden kann.
 ----------------------------------------------------------------------------}
begin
  Ref:=p.L+p.M*longint(256)+p.H*65536; { Drei Bytes zusammensetzen }
end;

{----------------------------------------------------------------------------}
procedure CreateLabel(page: word; name: LabelStr);
{----------------------------------------------------------------------------
  Diese Prozedur trgt den Label 'name' fr die Seite 'page' ein, sofern
  diese Seite nicht bereits einen Label hat. Falls bereits ein Label dieses
  Namens existiert, so wird durch Anhngen von '_' und einer Zahl ein neuer
  einzigartiger Label gebildet. Ziffernfolgen werden durch Voranstellen von
  '_' in alphanumerische Strings umgewandelt, um Verwechselungen mit Zahlen
  zu vermeiden (fr automatische Labelerzeugung aus Stichworten).
 ----------------------------------------------------------------------------}
const
  ValidLabel:set of char=['0'..'9','A'..'Z','a'..'z','_','^','[',']'];
var
  p,p2: LabelRecPtr;
  l,l2: LabelStr;
  s:    string;
  n:    byte;
  nonnumeric: boolean;
begin
  nonnumeric:=false;
  for n:=1 to length(name) do          { Label Zeichen fr Zeichen durch }
    if not (name[n] in ValidLabel) then
      name[n]:='_'                     { '_' statt ungltiger Labelzeichen }
    else
      nonnumeric:=nonnumeric or (name[n]>'9') or (name[n]<'0');
                                       { Prfen, ob nur Ziffern }
  if not nonnumeric then               { Label besteht nur aus Ziffern? }
    name:='_'+copy(name,1,15);         { Verwechselung mit Zahlen verhindern }
  if UpLabels then                     { Nur Grobuchstaben-Labels? }
    for n:=1 to length(name) do        { Label zeichenweise durch }
      name[n]:=UpCase(name[n]);        { In Grobuchstaben umwandeln }
  p:=LabelList^.next;                  { Anfang der Labelliste }
  while (p<>NIL) and (p^.page<>page) do
    p:=p^.next;                        { Prfen, ob Seite schon eintragen }
  if p<>NIL then                       { Seite schon eingetragen? }
    exit;                              { Dann schon fertig - nichts ndern }
  l:=name;                             { Erst Suche nach Originallabel }
  n:=2;                                { Zhlung des Elements }
  repeat
    p:=LabelList;                      { Suche immer vom Anfang d. Labelliste }
    while (p^.next<>NIL) and (p^.next^.lab<l) do
      p:=p^.next;                      { Position oder Listenende suchen }
    l2:=l;                             { Gesuchtes Element merken }
    str(n,s);                          { Folgenummer }
    l:=copy(name,1,13)+'_'+s;          { Evtl. Element+Folgenummer suchen }
    inc(n);                            { Nummer weiterzhlen }
  until (p^.next=NIL) or (p^.next^.lab<>l2);
                                       { So lange weiter, bis nicht vorhanden }
  new(p2);                             { Neuen Eintrag erzeugen }
  p2^.lab:=l2;                         { Labelnamen eintragen }
  p2^.page:=page;                      { Seitennumer eintragen }
  p2^.next:=p^.next;                   { Verkettung auf nchstes Element }
  p^.next:=p2;                         { Zeiger in vorhergehendes Element }
end;

{----------------------------------------------------------------------------}
procedure Get_Dir_and_Index;
{----------------------------------------------------------------------------
  Diese Prozedur liest das Seitenverzeichnis und die Indexliste aus der Datei
  ein. Die Indexliste wird als verkettete Liste auf dem Heap abgelegt, das
  Seitenverzeichnis kommt ins Array 'PageDir'.
 ----------------------------------------------------------------------------}

var
  i,n:	   word;
  b1,b2:   byte;
  j,k:	   byte;
  s:	   string;
  p,p_old: IndexPtr;

begin
  read(f,b1,b1,b1, b1,b2);	       { Verzeichnis: ID und Lnge berlesen }
  Pages:=b1+b2*256;		       { Anzahl der Seiten bestimmen }
  for i:=0 to Pages-1 do	       { Fr jede Seite einen 3-Byte-Eintrag }
    with PageDir[i] do		       { ins Array PageDir lesen }
      read(f,L,M,H);
  read(f,b1,b1,b1, b1,b2);	       { Index: ID und Lnge berlesen }
  n:=b1+b2*256;			       { Anzahl der Stichworte }
  Idx:=NIL;                            { Liste ist noch leer }
  s:='';
  for i:=1 to n do		       { Alle Stichworte durchgehen }
    begin
      New(p);	                       { Platz fr ein Stichwort anfordern }
      if Idx<>NIL then                 { Nicht erstes Stichwort: }
        p_old^.next:=p		       { Verkettung im vorhergehenden Stichw. }
      else
        Idx:=p;                        { Erstes: Listenanfang merken }
      read(f,b1);		       { Lngenbyte lesen }
      s:=copy(s,1,(b1 shr 5) and $07); { Obere 3 Bits geben an, wieviele Zei-
					 chen vom letzten Sw genommen werden }
      b1:=b1 and $1F;		       { Untere 5 Bits geben Restlnge an }
      for j:=1 to b1 do		       { Soviele Zeichen holen }
	begin
	  read(f,b2);		       { Ein Zeichen holen }
	  ConcatChar(s,char(b2));      { und an das Stichwort anfgen }
	end;
      p^.entry:=s;		       { In Liste eintragen }
      read(f,b1,b2);		       { Verweis-Seite holen }
      p^.ref:=b1+b2*256;	       { und eintragen }
      if IndexLabels then              { Falls Indexeintrge als Labels... }
        CreateLabel(p^.ref,copy(s,1,16));
                                       { Label aus Indexeintrag erzeugen }
      p_old:=p;			       { Zeiger auf Eintrag fr spter merken }
      p_old^.next:=NIL;		       { Vorerst letzter Eintrag }
    end;
end;

{----------------------------------------------------------------------------}
function PageNumber(num: word): string;
{----------------------------------------------------------------------------
  Diese Funktion liefert die Seitennummer 'num' zurck, eventuell auch als
  Label formatiert, falls dies beim Aufruf gewnscht worden ist. Sofern
  in der Labeltabelle ein Name fr die Seite eintragen ist, wird dieser
  verwendet.
 ---------------------------------------------------------------------------}
var
  s: string;
  p: LabelRecPtr;
begin
  p:=LabelList^.next;                  { Zeiger auf erstes Element }
  while (p<>NIL) and (p^.page<>num) do { Bis Listenende oder Seiteneintrag }
    p:=p^.next;
  if p<>NIL then                       { Seite gefunden }
    begin
      PageNumber:=p^.Lab;              { Label zurckgeben }
      exit;                            { Prozedur fertig }
    end;
  str(num,s);                          { Seitenzahl in String umwandeln }
  if LabelPref<>''then                 { Labels erzeugen? }
    begin
      while length(s)<4 do             { Ja: Falls krzer als vier Stellen }
        s:='0'+s;                      { ...dann vorne mit Nullen auffllen }
      s:=LabelPref+s;                  { Label-Vorsatz anfgen }
    end;
  PageNumber:=s;                       { Ergebnis zurck }
end;

{----------------------------------------------------------------------------}
procedure DisplayText;
{----------------------------------------------------------------------------
  Die folgende Prozedur decodiert die Textseite, auf deren Anfang 'f' beim
  Aufruf zeigt, und schreibt sie inklusive Topic-Buttons in die Ausgabe-
  datei 'out'. Nach der Rckkehr stehen in 'PgUp' und 'PgDn' die Verkettungen
  vorwrts und rckwrts bzw. $0000, wenn keine Verkettung vorhanden ist.
 ----------------------------------------------------------------------------}

type
  ButtonT=record
            page:            word;
            line,col,endcol: byte;
            first:           boolean;
          end;
  WordP  =^word;
var
  GetNext:  boolean;
  ThisByte: byte;
  len:	    integer;
  n:	    Nibble;
  i:        integer;
  j,rep:    byte;
  Special:  boolean;
  b1,b2:    byte;
  c:	    char;
  line,col: byte;
  pos:      longint;
  flag:     boolean;
  exitflag: boolean;

  numbut:   integer;
  button:   array [1..256] of ButtonT;
  temp:     ButtonT;
  curbut:   integer;
  OpenBut:  boolean;
  PageList: WordP;

  {---------------------------------------------------------------------------}
  function PageListP(page: word): WordP;
  {---------------------------------------------------------------------------}
  begin
    PageListP:=Ptr(Seg(PageList^),Ofs(PageList^)+page*2);
  end;

  {---------------------------------------------------------------------------}
  function GetNibble: Nibble;
  {---------------------------------------------------------------------------
    Diese Funktion holt ein einzelnes Halbbyte (Nibble) aus der Datei 'f'.
    Dabei wird immer zuerst das niederwertige Halbbyte eines Bytes geladen.
   ---------------------------------------------------------------------------}
  begin
    if GetNext then		       { Wieder ein neues Byte holen? }
      begin
	read(f,ThisByte);	       { Ja: Byte lesen }
	dec(len);		       { Lnge herunterzhlen }
	GetNibble:=ThisByte and $0F;   { Niederwertiges Nibble isolieren }
	ThisByte:=ThisByte shr 4;      { Hherwertiges Nibble vorbereiten }
	GetNext:=false;		       { Beim nchsten Mal nicht lesen }
      end
    else
      begin
	GetNibble:=ThisByte;	       { Zweites Nibble des letzten Bytes }
	GetNext:=true;		       { Beim nchsten Mal wieder lesen }
      end;
  end;

  {---------------------------------------------------------------------------}
  procedure PutChar;
  {---------------------------------------------------------------------------
    Zeichen c, rep-mal wiederholt, ausgeben, eventuell auch Behandeln von
    Buttons nach dem "alten" Verfahren
   ---------------------------------------------------------------------------}
  begin
    if (vers>=6) and Special and
       ((c='A') or (c='B') or (c='C') or (c='E')) then
      begin                             { Steuerzeichen ab "neuer Version 2"? }
        case upcase(c) of                { Steuerzeichen auswerten }
          'A': begin                    { 'Ctrl-A' beendet Block }
                 GetNext:=true;         { Sofortiges Ende veranlassen }
                 len:=0;
               end;
          'B': begin                    { 'Ctrl-B' markiert Buttons }
                 OpenBut:=not OpenBut;  { Button offen/zu wechseln }
                 if PageListP(curbut-1)^<=Pages then
                                        { Button hat gltige Seitennummer }
                   if OpenBut then      { Button geffnet? }
                     write(out,c_markers[3])
                                        {Dann ffnungsmarkierung }
                   else
                     write(out,c_markers[3],PageNumber(PageListP(curbut-1)^),
                               c_markers[3]);
                                        { Markierung: Button-Ende/Verweis }
                 if not OpenBut then    { Button geschlossen }
                   inc(curbut);         { Weiter zum nchsten Button }
               end;
          'E': write(out,c_markers[3],c_markers[3],'H');
                                        { 'Ctrl-E' hebt Programmcode hervor }
          'F': write(out,c_markers[3],c_markers[3],'N');
                                        { 'Ctrl-F': Hervorhebung aus bis EOL }
        end;
        exit;
      end;
    if (vers<6) and                     { "Altes" Button-Handling }
       (curbut<=numbut) and (button[curbut].line=line) and
       (button[curbut].col=col) then    { Nchster Button beginnt hier? }
        write(out,c_markers[3]);        { Markierung: Button-Anfang }
    if Special then	                { Sonderzeichen: Prfix davor }
      write(out,c_markers[4]);
    write(out,c);	                { eigentliches Zeichen }
    if (vers<6) and                     { "Altes" Button-Handling }
       (curbut<=numbut) and (button[curbut].line=line) and
       (button[curbut].endcol=col) then { Button endet hier? }
      begin
        if button[curbut].page<=Pages then
          begin                         { Gltige Seitennummer? }
            write(out,c_markers[3]);    { Button-Text-Ende }
            if button[curbut].first then{ Erster Button? }
              write(out,c_markers[3]);  { Markierung verdoppeln }
            write(out,PageNumber(button[curbut].page),
                      c_markers[3]);    { Markierung: Verweis/Verweis-Ende }
          end;
        inc(curbut);                    { Button erledigt }
      end;
    inc(col);                           { Nchste Spalte }
  end;

begin
  read(f,b1, b1,b2);		       { ID berspringen, Textlnge lesen }
  len:=b1+b2*256;		       { Textlnge berechnen }
  pos:=filepos(f);                     { Position des Textes merken }

  seek(f,pos+len);                     { Zum Anfang des Info-Blocks }
  read(f,b1,b1,b1, b1,b2);	       { Rckverweis-Seite (PgUp) lesen }
  p_PgUp:=b1+b2*256;
  read(f,b1,b2);		       { Vorverweis-Seite (PgDn) lesen }
  p_PgDn:=b1+b2*256;
  if vers<6 then
{ *** "altes" Button-Handling *********************************************** }
    begin
      read(f,b1);		       { Anzahl der "Buttons" lesen }
      numbut:=b1;
      for i:=1 to numbut do	       { Buttons einlesen }
        with button[i] do
          begin
            read(f,line,col,endcol, b1,b1,b1,b1, b1,b2);
                                       { Button-Position und -Verweis lesen }
            page:=b1+b2*256;           { Verweis merken }
            dec(col,but_offset);       { Spalten um Rand korrigieren }
            dec(endcol,but_offset);
            first:=(i=1);              { Ersten Button in Liste markieren }
          end;
{ Buttons nach Anfangsposition sortieren (Bubblesort) }
      flag:=true;
      repeat
        for i:=1 to numbut-1 do
          if ((button[i].line>button[i+1].line) or
              ((button[i].line=button[i+1].line) and
               (button[i].col>button[i+1].col)))
            then begin
              temp:=button[i];
              button[i]:=button[i+1];
              button[i+1]:=temp;
              flag:=true;
            end;
      until flag;
    end
  else
{ *** "neues" Button-Handling *********************************************** }
    begin
      read(f,b1,b2);		       { Anzahl der "Buttons" lesen }
      numbut:=b1+b2*256;               { neu: 2 Bytes! }
      if numbut>0 then                 { Buttons da? }
        getmem(PageList,numbut*SizeOf(PageList^));
                                       { Platz fr Button-Liste anfordern }
      for i:=1 to numbut do	       { Buttons einlesen }
        with button[i] do
          begin
            read(f,b1,b2);             { Button-Verweis lesen }
            PageListP(i-1)^:=b1+b2*256;{ Verweis merken }
          end;
    end;

  seek(f,pos);                         { Zurck zum Textblock }
  GetNext:=true;		       { Sofort ein Byte lesen }
  line:=1;			       { Momentan Zeile/Spalte 1 des Schirms }
  col:=1;
  curbut:=1;                           { Ersten Button prfen }
  OpenBut:=false;                      { Gerade/ungerade Zahl Buttons }
  if vers<6 then                       { Altes Button-Handling }
    while (curbut<=numbut) and (button[curbut].line<line) do
      inc(curbut);                     { Evtl. Buttons in Zeile 0 ignorieren }
  while (len>0) or not GetNext do      { Solange noch Nibbles zu lesen }
    begin
      n:=GetNibble;		       { Ein Nibble holen }
      if n=$E then		       { $E: Zeichenwiederholung }
	begin
	  rep:=GetNibble+2;	       { Nchstes Nibble: Wiederholungen-2 }
	  n:=GetNibble;		       { folgendes Zeichen holen }
	end
      else
	rep:=1;			       { Ansonsten nur einmal }
      if n=$F then		       { ASCII-Zeichen? }
	begin
	  n:=GetNibble;		       { Dann zwei Nibbles Zeichencode }
	  c:=char(n+GetNibble*16);
	end
      else
	c:=Short[n];		       { ansonsten als Kurzzeichen decodieren }
      if c in SpecialSet then	       { Ein Sonderzeichen (Ctrl oder Marker) }
        begin
          if c<' 'then                 { Steuerzeichen? }
            inc(c,64);                 { Korrigieren auf Grobuchstaben }
          Special:=true;               { Merken: Sonderzeichen-Prefix }
	end
      else
        Special:=false;                { kein Sonderzeichen }
      for i:=1 to rep do               { Zeichen rep-mal wiederholen }
        begin
          if c=#0 then                 { #00: Zeilenvorschub }
            begin
              writeln(out);            { Zeile ausgeben }
              if vers<6 then           { "Altes" Button-Handling }
                begin
                  c:=' ';              { Mit Blanks fllen }
                  Special:=false;      { Keine Sonderzeichenbehandlung }
                  while (curbut<=numbut) and (button[curbut].line=line) do
                    PutChar;           { Eventuell Buttons am Zeilenende }
                end;
              inc(line);               { Eine Zeile weiter }
              col:=1;                  { Zurck in der ersten Spalte }
	      OpenBut:=false;	       { Offene Buttons vergessen }	
            end
          else
            PutChar;                   { Zeichen ausgeben }
        end;
    end;
    if vers<6 then                     { "Altes" Button-Handling }
      begin
        c:=' ';                        { Mit Blanks fllen }
        Special:=false;                { Keine Sonderzeichenbehandlung }
        while (curbut<=numbut) and (button[curbut].line=line) do
          PutChar;                     { Eventuell Buttons am Zeilenende }
      end;
    if col>1 then                      { Noch Zeichen in letzter Zeile? }
      writeln(out);                    { Zeile abschlieen }
    if (vers>=6) and (numbut>0) then   { Eventuell Button-Liste freigeben }
      dispose(PageList);
end;

{----------------------------------------------------------------------------}
procedure SplitOpen;
{----------------------------------------------------------------------------
  Diese Prozedur ffnet eine neue Teildatei, schaltet die Nummer im Datei-
  namen weiter und trgt den Namen der Teildatei in der Header-Datei ein.
  Dabei wird die Darstellung '*.ext' benutzt, um dafr zu sorgen, da beim
  Compilieren der Pfadname der Header-Datei beliebig gewhlt werden kann.
 ----------------------------------------------------------------------------}
var
  s:    string[3];
  name: string;
begin
  str(FileCount,s);                    { Dateinummer in String umwandeln }
  while length(s)<3 do                 { Auf 3 Stellen mit fhrenden Nullen }
    s:='0'+s;
  assign(out,AddExt(outfile,s));       { Dateinamen erzeugen und setzen }
  rewrite(out);                        { Zum Schreiben ffnen }
  writeln(out,'@  Decompiled ''',infile,''' - subfile #',FileCount+1);
  writeln(out);                        { Kopf der Ausgabedatei }
  inc(FileCount);                      { Dateizhler weiter }
  writeln(headf,'$ *.',s);             { Namen in Header-Datei }
end;

{----------------------------------------------------------------------------}

begin
  assign(stderr,'CON');                { Standard-Fehlerausgabe erzeugen }
  rewrite(stderr);

  writeln;
  writeln('HELPREAD 1.21 -=- Borland(TM) Help File DeCompiler');
  writeln('written by Marcus Grber & Torsten Brand 1989-92');
  writeln;

  LabelPref:='';                       { default: keine Labels erzeugen }
  IndexLabels:=false;                  { default: keine Index-Labels }
  SplitSize:=0;                        { default: keine Dateiteilung }

{ Kommandozeilenparser: }
  parnum:=1;                           { Standard: Dateinamen ab 1. Parameter }
  namepar:=0;                          { Noch kein Namensparameter gelesen }
  infile:='';                          { Keine Namen gelesen }
  outfile:='';
  repeat
    par:=ParamStr(parnum);             { Parameter lesen }
    if (length(par)>1) and ((par[1]='-') or (par[1]='/')) then
      begin                            { Switches? }
        case UpCase(par[2]) of         { Switches auswerten }
          'I': IndexLabels:=true;      { -I - Indexeintrge als Labels }
          'U': UpLabels:=true;         { -U - Grobuchstaben-Labels }
          'L': begin                   { -L<prefix> - Labelprfix setzen }
                 LabelPref:=copy(par,3,12);
                                       { Parameter holen }
                 if LabelPref=''then   { Kein Parameter? }
                   LabelPref:='P';     { default-Prfix: 'P' }
               end;
          'S': begin                   { -S<pages> - Dateigre setzen }
                 val(copy(par,3,4),SplitSize,j);
                                       { Parameter holen }
                 if j<>0 then          { Ungltig? }
                   SplitSize:=100;     { default: 100 Seiten }
               end;
          else begin
                 writeln('Invalid option: -',par[2]);
                 halt(1);              { unbekannt: Fehlermeldung/Abbruch }
               end;
        end;
      end
    else if par<>'' then
      begin
        inc(namepar);                  { Parameter zhlen }
        if namepar=1 then              { Erster Parameter ist Eingabedatei }
          infile:=par
        else if namepar=2 then         { Zweiter Parameter ist Ausgabedatei }
          outfile:=par;
      end;
    inc(parnum);                       { Nchster Paramter }
  until (par='');                      { Wiederholen, bis keine Parameter }
  if infile='' then                    { Kein Eingabefile angegeben? }
    begin                              { Fehler: Syntaxbeschreibung }
      writeln('Usage: HELPREAD [options] <helpfile> [<destin>]');
      writeln('options: -i    use index entries as label names');
      writeln(     #09' -u    force uppercase labels (only with -i)');
      writeln(     #09' -l<p> create page labels with prefix <p>');
      writeln(     #09' -s<n> split: open new file after <n> pages');
      halt(1);
    end;
  if outfile=''then                    { Kein Ausgabefile? }
    outfile:=AddExt(infile,'HCS');     { default: helpfile.HCS }

  HeapError:=@HeapErrorHandler;        { Behandlung von Speicher-voll-Fehlern }
  assign(f,infile);		       { Dateien ffnen }
  {$I-} reset(f); {$I+}                { Zum Lesen ffnen }
  if IOResult<>0 then                  { Fehlschlag? }
    begin
      writeln('Cannot open input file.');
      halt(2);                         { Mit Fehlermeldung abbrechen }
    end;
  assign(out,outfile);
  rewrite(out);
  New(LabelList);                      { Dummy-Eintrag am Anfang erzeugen }
  LabelList^.next:=NIL;                { Noch keine weiteren Eintrge }

  writeln('Reading header and index...');
  Get_Header;			       { Kopf der Datei einlesen }
  if IndexLabels then                  { Falls Labels gewnscht }
    CreateLabel(IndexPg,'Index_Page'); { dann Inhaltsverzeichnis benennen }
  Get_Dir_and_Index;		       { Seitenverzeichnis und Index lesen }

{ "Kopf" der Datei erzeugen: Kommentare, Titel, Markerdefinition, Indexseite,
  Optionen ('case sensitivity') }
  writeln(out,'M ',c_markers);
  writeln(out);
  writeln(out,'@');
  writeln(out,'@   Decompiled Turbo Help File ''',infile,'''');
  write  (out,'@   File format: ');
    if vers=4 then
      writeln(out,'"old" (TurboPascal 4.0) - compile: HELPMAKE -t0')
    else if vers=5 then
      writeln(out,'"new" (THELP 1.0) - compile: HELPMAKE -t1')
    else if vers=6 then
      if TypeID=5 then
        writeln(out,'"new 2" (THELP 2.0) - compile: HELPMAKE -t2')
      else
        writeln(out,'"new 2" (THELP 2.0) - compile: HELPMAKE -t2 -x',TypeID);
  writeln(out,'@');
  writeln(out);
  writeln(out,'T ',Title);
  writeln(out,'P ',ProgCode);
  writeln(out);
  writeln(out,'S ',scr_width,',',scr_height);
  write	 (out,'O ');
    if (Options and $04)>0 then
      writeln(out,'Case')
    else
      writeln(out,'NoCase');
  writeln(out,'X ',PageNumber(IndexPg));
  writeln(out);

  if SplitSize<>0 then                 { Falls Dateiaufteilung... }
    begin
      TextRec(headf):=TextRec(out);    { Kopfdatei merken }
      TextRec(headf).BufPtr:=@TextRec(headf).Buffer;
                                       { Zeiger auf korrekten Puffer }
      FileCount:=0;                    { Noch keine Unterdateien }
      SplitOpen;                       { Erste Unterdatei erffnen }
    end;

  PageCount:=0;                        { Noch keine Seiten geschrieben }
  writeln('Decompiling help text...');
  write(stderr,'     pages left');
  for pg:=1 to Pages-1 do
    if PageDir[pg].H<$FF then	       { Ist diese Seite eingetragen? }
      begin			       { Ja: }
	write(stderr,#13,Pages-pg:4);  { Bildschirmcountdown }

        if (SplitSize<>0) and (PageCount>=SplitSize) then
          begin                        { Genug Daten in Teildatei? }
            close(out);                { Dann Teildatei schlieen }
            SplitOpen;                 { Neue Teildatei ffnen }
            PageCount:=0;
          end;
        inc(PageCount);                { Geschriebene Seiten zhlen }

	fptr:=Ref(PageDir[pg]);	       { Dateiposition der Seite errechnen }
	write(out,c_markers[1],'P ',PageNumber(pg));
                                       { "Seitenrahmen" ausgeben }
	cnt:=1;			       { Schon 1 Seitennummer in der Zeile }
	for p2:=pg+1 to Pages-1 do     { Ab aktueller Seite nach weiteren }
	  begin			       { Querverweisen auf diese Seite suchen }
	    if Ref(PageDir[p2])=fptr then
	      begin		       { Falls gefunden... }
		write(out,',');	       { Komma hinter letztem Verweis }
		if cnt=12 then
		  begin
		    writeln(out);      { ...gibt's `ne neue Zeile }
                    write(out,'':3);   { Ein bichen einrcken }
		    cnt:=0;	       { Noch keine Nummern drin }
		  end;
		write(out,PageNumber(p2));
                                       { Nummer des Zusatzverweises ausgeben }
		inc(cnt);	       { Seitennummern pro Zeile zhlen }
	      end;
	  end;
	writeln(out);		       { Neue Zeile nach Rahmenanfang }
	Seek(f,fptr);		       { Textanfang anspringen }
	DisplayText;		       { Schirm einlesen }
	write(out,c_markers[2]);       { Schliezeichen }
	if (p_PgUp>0) or (p_PgDn>0) then
	  begin			       { Rckverweis-Klammern, falls vorhanden
					 oder falls Vorwerweis existiert }
	    write(out,'<');
	      if p_PgUp>0 then	       { Rckverweis eintragen, falls da }
		write(out,PageNumber(p_PgUp));
	    write(out,'>');
	  end;
	if p_PgDn>0 then	       { Vorwerweis & Klammern nur, falls da }
	  write(out,'<',PageNumber(p_PgDn),'>');
	writeln(out);		       { Nach all dem eine neue Zeile! }

{ Der folgende Abschnitt gibt nach der eigentlichen Seitenbeschreibung
  alle Indexbegriffe aus, die auf eine Seite fhren, zu welcher die Seiten-
  beschreibung gehrt (knnten theoretisch auch mehrere sein). Nachdem ein
  Eintrag einmal benutzt worden ist, wird er aus der verketteten Liste und
  aus dem Speicher entfernt (da jedes Stichwort nur auf eine Seite
  zeigen kann). }
	p:=Idx;			       { Anfang der Indexbegriffsliste }
	p_last:=nil;
	while p<>nil do		       { Solange noch Eintrge... }
	  begin
	    if Ref(PageDir[p^.ref])=fptr then
				       { Indexbegriff fr eine Seite, die
					 den Text der augenblicklichen ent-
					 hlt? (kompliziert, was) }
	      begin
		writeln(out,'I ',PageNumber(p^.ref),' ',p^.entry);
				       { Ja: Dann ausgeben }
		p_save:=p^.next;       { Nchsten Eintrag merken }
		if p_last<>nil then    { Schon Eintrge davor? }
		  p_last^.next:=p_save { Ja: dann dort dafr sorgen, da }
		else			{ dieser Eintrag bersprungen wird }
		  Idx:=p_save;	       { Ansonsten neues Anfangselement }
		Dispose(p);	       { Diesen Eintrag wieder freigeben }
		p:=p_save;	       { Zum nchsten Eintrag }
	      end
	    else
	      begin
		p_last:=p;	       { Eintrag fr nchsten Lauf merken }
		p:=p^.next;	       { Einfach nchster Eintrag }
	      end;
	  end;

	for p2:=pg+1 to Pages-1 do     { Ab aktueller Seite nach weiteren }
				       { Querverweisen auf diese Seite suchen }
	  if Ref(PageDir[p2])=fptr then{ Verweis gefunden: }
	    PageDir[p2]:=NoPage;       { Verweis lschen/nicht bearbeiten }
      end;

  if SplitSize<>0 then                 { Dateiaufteilung? }
    close(headf);                      { Dann Kopfdatei schlieen }
  close(out);                          { Textdatei schlieen }
  close(f);

  writeln(#13,'File successfully processed.');
  Halt(0);
end.
